%This GUI uses the method-of-lines with either 1 or 2 spatial dimensions in
%a Krogh cylinder for the distribution of small molecules, biologics, and
%nanoparticles in tumors. 
%Emily Deschenes, Thurber Lab, 2014, University of Michigan

function varargout = KroghGUI_5_4_15(varargin)
% KROGHGUI_5_4_15 MATLAB code for KroghGUI_5_4_15.fig
%      KROGHGUI_5_4_15, by itself, creates a new KROGHGUI_5_4_15 or raises the existing
%      singleton*.
%
%      H = KROGHGUI_5_4_15 returns the handle to a new KROGHGUI_5_4_15 or the handle to
%      the existing singleton*.
%
%      KROGHGUI_5_4_15('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in KROGHGUI_5_4_15.M with the given input arguments.
%
%      KROGHGUI_5_4_15('Property','Value',...) creates a new KROGHGUI_5_4_15 or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before KroghGUI_5_4_15_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to KroghGUI_5_4_15_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help KroghGUI_5_4_15

% Last Modified by GUIDE v2.5 02-Jul-2015 03:09:09

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @KroghGUI_5_4_15_OpeningFcn, ...
                   'gui_OutputFcn',  @KroghGUI_5_4_15_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before KroghGUI_5_4_15 is made visible.
function KroghGUI_5_4_15_OpeningFcn(hObject, ~, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to KroghGUI_5_4_15 (see VARARGIN)

% Choose default command line output for KroghGUI_5_4_15
handles.output = hObject;

% Update handles structure
guidata(hObject, handles);

% INITIALIZE ERROR COUNT AND USE GUIDATA TO UPDATE THE HANDLES STRUCTURE.
handles.number_errors = 0;

%__________________________________________________________________________
%initialize all inputs in case user doesn't enter new data
%These values must be in agreement with the initial values in the fig file
%for the GUI - the values below will be used if the user doesn't enter any
%data
handles.Dose = 100;             %nM
handles.Diff_coeff = 10;        %um^2/s
handles.Perm = 0.003;           %um/s
handles.Kon = 100000;           %/M/s
handles.Kequil = 1;             %nM
handles.Void_frac = 0.1;        %unitless
handles.SAtoVratio = 60;       %/cm
handles.plasma_volume = 2;      %mL
handles.cap_radius = 8;         %um
handles.vessel_length = 500;    %um
handles.axial_points = 15;      %unitless
handles.radial_points = 30;     %unitless
handles.half_life = 24;         %hrs - storage for single exponential
handles.bi_alpha_half_life = 2;   %hrs - storage for biexponential
handles.bi_beta_half_life = 24;    %hrs - storage for biexponential
handles.bi_fraction_alpha = 0.5;   %unitless - storage for biexponential
handles.alpha_half_life = 2;   %hrs - working value
handles.beta_half_life = 24;    %hrs - working value
handles.fraction_alpha = 0.5;   %unitless - working value
handles.radio_button = 0;
handles.radiobutton1 = 0;
handles.radiobutton2 = 0;
handles.time = 24;              %hours
handles.count = 0;
handles.axial_point_button = 1;
handles.biot = 1;
handles.vesseldepletion = 1;
handles.damkohler = 1;
handles.class = 1;
handles.free_fraction = 1.0;
handles.hematocrit = 0.45;
handles.receptor = 1e6;
handles.internalization = 15;
handles.toggle = 0;

% Update handles structure
guidata(hObject, handles);

% UIWAIT makes KroghGUI_5_4_15 wait for user response (see UIRESUME)
% uiwait(handles.figure1);


% --- Outputs from this function are returned to the command line.
function varargout = KroghGUI_5_4_15_OutputFcn(~, ~, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;


% --- Executes on button press in pushbutton_sim.
function pushbutton_sim_Callback(hObject, ~, handles) %#ok<*DEFNU>
% hObject    handle to pushbutton_sim (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

h_selectedRadioButton = get(handles.uipaneldecay,'SelectedObject');
selectedRadioTag = get(h_selectedRadioButton,'tag');

switch selectedRadioTag
    case 'single'
        handles.radio_button = 1;
        guidata(hObject,handles);    % Stores value in handles 
    case 'bi'
        handles.radio_button = 2; 
        guidata(hObject,handles);    % Stores value in handles 
end

if(handles.radio_button == 1)
        handles.alpha_half_life = 1;
        handles.fraction_alpha = 0;
        handles.beta_half_life = handles.half_life;
        guidata(hObject,handles);

else
        handles.alpha_half_life = handles.bi_alpha_half_life;
        handles.fraction_alpha = handles.bi_fraction_alpha;
        handles.beta_half_life = handles.bi_beta_half_life;
        guidata(hObject,handles); 
end

selectedRadioButton = get(handles.uipanel1Dor2D,'SelectedObject');
selectedRadioTag2 = get(selectedRadioButton,'tag');

switch selectedRadioTag2
    case 'oneD'
        handles.axial_point_button = 1;
        guidata(hObject,handles);
    case 'twoD'
        handles.axial_point_button = 2;
        guidata(hObject,handles);    % Stores value in handles 
end

selectedRadioButton2 = get(handles.uipanelsimtime,'SelectedObject');
selectedRadioTag3 = get(selectedRadioButton2,'tag');

switch selectedRadioTag3
    case 'yes'
        handles.count=1;
        guidata(hObject,handles);    % Stores value in handles
    case 'no'
        handles.count =2;
        guidata(hObject,handles);    % Stores value in handles 
end

if(handles.axial_point_button == 1) 
            output = cylindrical_model_IDpergram(handles); %#ok<NASGU>
else 
            output = Full_Krogh_w_Jacob_8_3_10(handles); %#ok<NASGU>
end

% --- Executes on button press in pushbutton_calc.
function pushbutton_calc_Callback(~, ~, handles)
% hObject    handle to pushbutton_calc (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

calc_dimensionless(handles)


function edit_biot_Callback(~, ~, ~)
% hObject    handle to edit_biot (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_biot as text
%        str2double(get(hObject,'String')) returns contents of edit_biot as a double


% --- Executes during object creation, after setting all properties.
function edit_biot_CreateFcn(hObject, ~, ~)
% hObject    handle to edit_biot (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function edit_vessel_dep_Callback(~, ~, ~)
% hObject    handle to edit_vessel_dep (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_vessel_dep as text
%        str2double(get(hObject,'String')) returns contents of edit_vessel_dep as a double


% --- Executes during object creation, after setting all properties.
function edit_vessel_dep_CreateFcn(hObject, ~, ~)
% hObject    handle to edit_vessel_dep (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function edit_damkohler_Callback(~, ~, ~)
% hObject    handle to edit_damkohler (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_damkohler as text
%        str2double(get(hObject,'String')) returns contents of edit_damkohler as a double


% --- Executes during object creation, after setting all properties.
function edit_damkohler_CreateFcn(hObject, ~, ~)
% hObject    handle to edit_damkohler (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function edit_class_Callback(~, ~, ~)
% hObject    handle to edit_class (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_class as text
%        str2double(get(hObject,'String')) returns contents of edit_class as a double


% --- Executes during object creation, after setting all properties.
function edit_class_CreateFcn(hObject, ~, ~)
% hObject    handle to edit_class (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function edit_half_life_Callback(hObject, ~, handles)
% hObject    handle to edit_half_life (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_half_life as text
%        str2double(get(hObject,'String')) returns contents of edit_half_life as a double
val_half_life = str2double(get(hObject,'String'));

% Determine whether val is a number between 0 and 1.
if isnumeric(val_half_life) && length(val_half_life)==1 && ...
   val_half_life >= get(handles.slider_half_life,'Min') && ...
   val_half_life <= get(handles.slider_half_life,'Max')
   set(handles.slider_half_life,'Value',val_half_life);
   
   handles.half_life = val_half_life;  %Converts text to number and stores as handles.half_life 
   guidata(hObject,handles);    %stores value in handles 
   
else
% Increment the error count, and display it.
   handles.number_errors = handles.number_errors+1;
   guidata(hObject,handles); % Store the changes.
   set(hObject,'String',...
   ['You have entered an invalid entry ',...
    num2str(handles.number_errors),' times.']);
   % Restore focus to the edit text box after error
   uicontrol(hObject)
end


% --- Executes during object creation, after setting all properties.
function edit_half_life_CreateFcn(hObject, ~, ~)
% hObject    handle to edit_half_life (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on slider movement.
function slider_half_life_Callback(hObject, ~, handles)
% hObject    handle to slider_half_life (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'Value') returns position of slider
%        get(hObject,'Min') and get(hObject,'Max') to determine range of slider
   set(handles.edit_half_life,'String',...                  % Changes text box to slider value 
   num2str(get(handles.slider_half_life,'Value')));

   handles.half_life = get(handles.slider_half_life,'Value');  % Converts text to number and stores as handles.half_life
   guidata(hObject,handles);    % Stores value in handles 


% --- Executes during object creation, after setting all properties.
function slider_half_life_CreateFcn(hObject, ~, ~)
% hObject    handle to slider_half_life (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: slider controls usually have a light gray background.
if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end


function edit_alpha_half_life_Callback(hObject, ~, handles)
% hObject    handle to edit_alpha_half_life (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_alpha_half_life as text
%        str2double(get(hObject,'String')) returns contents of edit_alpha_half_life as a double
val_alpha_half_life = str2double(get(hObject,'String'));

% Determine whether val is a number between 0 and 1.
if isnumeric(val_alpha_half_life) && length(val_alpha_half_life)==1 && ...
   val_alpha_half_life >= get(handles.slider_alpha_half_life,'Min') && ...
   val_alpha_half_life <= get(handles.slider_alpha_half_life,'Max')
   set(handles.slider_alpha_half_life,'Value',val_alpha_half_life);
   
   handles.bi_alpha_half_life = val_alpha_half_life;  %Converts text to number and stores as handles.alpha_half_life 
   guidata(hObject,handles);    %stores value in handles 
   
else
% Increment the error count, and display it.
   handles.number_errors = handles.number_errors+1;
   guidata(hObject,handles); % Store the changes.
   set(hObject,'String',...
   ['You have entered an invalid entry ',...
    num2str(handles.number_errors),' times.']);
   % Restore focus to the edit text box after error
   uicontrol(hObject)
end


% --- Executes during object creation, after setting all properties.
function edit_alpha_half_life_CreateFcn(hObject, ~, ~)
% hObject    handle to edit_alpha_half_life (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on slider movement.
function slider_alpha_half_life_Callback(hObject, ~, handles)
% hObject    handle to slider_alpha_half_life (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'Value') returns position of slider
%        get(hObject,'Min') and get(hObject,'Max') to determine range of slider
   set(handles.edit_alpha_half_life,'String',...                  % Changes text box to slider value 
   num2str(get(handles.slider_alpha_half_life,'Value')));

   handles.bi_alpha_half_life = get(handles.slider_alpha_half_life,'Value');  % Converts text to number and stores as handles.alpha_half_life  
   guidata(hObject,handles);    % Stores value in handles 

   
% --- Executes during object creation, after setting all properties.
function slider_alpha_half_life_CreateFcn(hObject, ~, ~)
% hObject    handle to slider_alpha_half_life (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: slider controls usually have a light gray background.
if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end


function edit_beta_half_life_Callback(hObject, ~, handles)
% hObject    handle to edit_beta_half_life (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_beta_half_life as text
%        str2double(get(hObject,'String')) returns contents of edit_beta_half_life as a double
val_half_life_beta = str2double(get(hObject,'String'));

% Determine whether val is a number between 0 and 1.
if isnumeric(val_half_life_beta) && length(val_half_life_beta)==1 && ...
   val_half_life_beta >= get(handles.slider_beta_half_life,'Min') && ...
   val_half_life_beta <= get(handles.slider_beta_half_life,'Max')
   set(handles.slider_beta_half_life,'Value',val_half_life_beta);
   
   handles.bi_beta_half_life = val_half_life_beta;  %Converts text to number and stores as handles.beta_half_life
   guidata(hObject,handles);    %stores value in handles 
   
else
% Increment the error count, and display it.
   handles.number_errors = handles.number_errors+1;
   guidata(hObject,handles); % Store the changes.
   set(hObject,'String',...
   ['You have entered an invalid entry ',...
    num2str(handles.number_errors),' times.']);
   % Restore focus to the edit text box after error
   uicontrol(hObject)
end


% --- Executes during object creation, after setting all properties.
function edit_beta_half_life_CreateFcn(hObject, ~, ~)
% hObject    handle to edit_beta_half_life (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on slider movement.
function slider_beta_half_life_Callback(hObject, ~, handles)
% hObject    handle to slider_beta_half_life (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'Value') returns position of slider
%        get(hObject,'Min') and get(hObject,'Max') to determine range of slider
   set(handles.edit_beta_half_life,'String',...                  % Changes text box to slider value 
   num2str(get(handles.slider_beta_half_life,'Value')));

   handles.bi_beta_half_life = get(handles.slider_beta_half_life,'Value');  % Converts text to number and stores as handles.beta_half_life  
   guidata(hObject,handles);    % Stores value in handles 


% --- Executes during object creation, after setting all properties.
function slider_beta_half_life_CreateFcn(hObject, ~, ~)
% hObject    handle to slider_beta_half_life (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: slider controls usually have a light gray background.
if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end


function edit_fraction_alpha_Callback(hObject, ~, handles)
% hObject    handle to edit_fraction_alpha (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_fraction_alpha as text
%        str2double(get(hObject,'String')) returns contents of edit_fraction_alpha as a double
val_half_life_fracalpha = str2double(get(hObject,'String'));

% Determine whether val is a number between 0 and 1.
if isnumeric(val_half_life_fracalpha) && length(val_half_life_fracalpha)==1 && ...
   val_half_life_fracalpha >= get(handles.slider_fraction_alpha,'Min') && ...
   val_half_life_fracalpha <= get(handles.slider_fraction_alpha,'Max')
   set(handles.slider_fraction_alpha,'Value',val_half_life_fracalpha);
   
   handles.bi_fraction_alpha = val_half_life_fracalpha;  %Converts text to number and stores as handles.fraction_alpha  
   guidata(hObject,handles);    %stores value in handles 
   
else
% Increment the error count, and display it.
   handles.number_errors = handles.number_errors+1;
   guidata(hObject,handles); % Store the changes.
   set(hObject,'String',...
   ['You have entered an invalid entry ',...
    num2str(handles.number_errors),' times.']);
   % Restore focus to the edit text box after error
   uicontrol(hObject)
end


% --- Executes during object creation, after setting all properties.
function edit_fraction_alpha_CreateFcn(hObject, ~, ~)
% hObject    handle to edit_fraction_alpha (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on slider movement.
function slider_fraction_alpha_Callback(hObject, ~, handles)
% hObject    handle to slider_fraction_alpha (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'Value') returns position of slider
%        get(hObject,'Min') and get(hObject,'Max') to determine range of slider
   set(handles.edit_fraction_alpha,'String',...                  % Changes text box to slider value 
   num2str(get(handles.slider_fraction_alpha,'Value')));

   handles.fraction_alpha = get(handles.slider_fraction_alpha,'Value');  % Converts text to number and stores as handles.fraction_alpha 
   guidata(hObject,handles);    % Stores value in handles 


% --- Executes during object creation, after setting all properties.
function slider_fraction_alpha_CreateFcn(hObject, ~, ~)
% hObject    handle to slider_fraction_alpha (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: slider controls usually have a light gray background.
if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end


% --- Executes on slider movement.
function slider_perm_Callback(hObject, ~, handles)
% hObject    handle to slider_perm (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'Value') returns position of slider
%        get(hObject,'Min') and get(hObject,'Max') to determine range of slider
   set(handles.edit_perm,'String',...                  %Changes text box to slider value 
   num2str(get(handles.slider_perm,'Value')));

   handles.Perm = get(handles.slider_perm,'Value');  %Converts text to number and stores as handles.Perm 
   guidata(hObject,handles);    %stores value in handles 


% --- Executes during object creation, after setting all properties.
function slider_perm_CreateFcn(hObject, ~, ~)
% hObject    handle to slider_perm (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: slider controls usually have a light gray background.
if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end


function edit_perm_Callback(hObject, ~, handles)
% hObject    handle to edit_perm (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_perm as text
%        str2double(get(hObject,'String')) returns contents of edit_perm as a double
val_Perm = str2double(get(hObject,'String'));

% Determine whether val is a number between 0 and 1.
if isnumeric(val_Perm) && length(val_Perm)==1 && ...
   val_Perm >= get(handles.slider_perm,'Min') && ...
   val_Perm <= get(handles.slider_perm,'Max')
   set(handles.slider_perm,'Value',val_Perm);
   
   handles.Perm = val_Perm;  %Converts text to number and stores as handles.Perm  
   guidata(hObject,handles);    %stores value in handles 
   
else
% Increment the error count, and display it.
   handles.number_errors = handles.number_errors+1;
   guidata(hObject,handles); % Store the changes.
   set(hObject,'String',...
   ['You have entered an invalid entry ',...
    num2str(handles.number_errors),' times.']);
   % Restore focus to the edit text box after error
   uicontrol(hObject)
end


% --- Executes during object creation, after setting all properties.
function edit_perm_CreateFcn(hObject, ~, ~)
% hObject    handle to edit_perm (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on slider movement.
function slider_diff_coeff_Callback(hObject, ~, handles)
% hObject    handle to slider_diff_coeff (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'Value') returns position of slider
%        get(hObject,'Min') and get(hObject,'Max') to determine range of slider
   set(handles.edit_diff_coeff,'String',...                  %Changes text box to slider value 
   num2str(get(handles.slider_diff_coeff,'Value')));

   handles.Diff_coeff = get(handles.slider_diff_coeff,'Value');  %Converts text to number and stores as handles.Diff_coeff 
   guidata(hObject,handles);    %stores value in handles 

   
% --- Executes during object creation, after setting all properties.
function slider_diff_coeff_CreateFcn(hObject, ~, ~)
% hObject    handle to slider_diff_coeff (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: slider controls usually have a light gray background.
if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end


function edit_diff_coeff_Callback(hObject, ~, handles)
% hObject    handle to edit_diff_coeff (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_diff_coeff as text
%        str2double(get(hObject,'String')) returns contents of edit_diff_coeff as a double
val_diff_coeff = str2double(get(hObject,'String'));

% Determine whether val is a number between 0 and 1.
if isnumeric(val_diff_coeff) && length(val_diff_coeff)==1 && ...
   val_diff_coeff >= get(handles.slider_diff_coeff,'Min') && ...
   val_diff_coeff <= get(handles.slider_diff_coeff,'Max')
   set(handles.slider_diff_coeff,'Value',val_diff_coeff);
   
   handles.Diff_coeff = val_diff_coeff;  %Converts text to number and stores as handles.Diff_coeff  
   guidata(hObject,handles);    %stores value in handles 
   
else
% Increment the error count, and display it.
   handles.number_errors = handles.number_errors+1;
   guidata(hObject,handles); % Store the changes.
   set(hObject,'String',...
   ['You have entered an invalid entry ',...
    num2str(handles.number_errors),' times.']);
   % Restore focus to the edit text box after error
   uicontrol(hObject)
end


% --- Executes during object creation, after setting all properties.
function edit_diff_coeff_CreateFcn(hObject, ~, ~)
% hObject    handle to edit_diff_coeff (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function edit_dose_Callback(hObject, ~, handles)
% hObject    handle to edit_dose (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_dose as text
%        str2double(get(hObject,'String')) returns contents of edit_dose as a double
val = str2double(get(hObject,'String'));

% Determine whether val is a number between 0 and 1.
if isnumeric(val) && length(val)==1 && ...
   val >= get(handles.slider_dose,'Min') && ...
   val <= get(handles.slider_dose,'Max')
   set(handles.slider_dose,'Value',val);
   
   handles.Dose = val;  %Converts text to number and stores as handles.Dose  
   guidata(hObject,handles);    %stores value in handles 
   
else
% Increment the error count, and display it.
   handles.number_errors = handles.number_errors+1;
   guidata(hObject,handles); % Store the changes.
   set(hObject,'String',...
   ['You have entered an invalid entry ',...
    num2str(handles.number_errors),' times.']);
   % Restore focus to the edit text box after error
   uicontrol(hObject)
end


% --- Executes during object creation, after setting all properties.
function edit_dose_CreateFcn(hObject, ~, ~)
% hObject    handle to edit_dose (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on slider movement.
function slider_dose_Callback(hObject, ~, handles)
% hObject    handle to slider_dose (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'Value') returns position of slider
%        get(hObject,'Min') and get(hObject,'Max') to determine range of slider
   set(handles.edit_dose,'String',...                  %Changes text box to slider value 
   num2str(get(handles.slider_dose,'Value')));

   handles.Dose = get(handles.slider_dose,'Value');  %Converts text to number and stores as handles.Dose 
   guidata(hObject,handles);    %stores value in handles 

   
% --- Executes during object creation, after setting all properties.
function slider_dose_CreateFcn(hObject, ~, ~)
% hObject    handle to slider_dose (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: slider controls usually have a light gray background.
if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end


function edit_kon_Callback(hObject, ~, handles)
% hObject    handle to edit_kon (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_kon as text
%        str2double(get(hObject,'String')) returns contents of edit_kon as a double
val_Kon = str2double(get(hObject,'String'));

% Determine whether val is a number between 0 and 1.
if isnumeric(val_Kon) && length(val_Kon)==1 && ...
   val_Kon >= get(handles.slider_kon,'Min') && ...
   val_Kon <= get(handles.slider_kon,'Max')
   set(handles.slider_kon,'Value',val_Kon);
   
   handles.Kon = val_Kon;  %Converts text to number and stores as handles.Kon 
   guidata(hObject,handles);    %stores value in handles 
   
else
% Increment the error count, and display it.
   handles.number_errors = handles.number_errors+1;
   guidata(hObject,handles); % Store the changes.
   set(hObject,'String',...
   ['You have entered an invalid entry ',...
    num2str(handles.number_errors),' times.']);
   % Restore focus to the edit text box after error
   uicontrol(hObject)
end


% --- Executes during object creation, after setting all properties.
function edit_kon_CreateFcn(hObject, ~, ~)
% hObject    handle to edit_kon (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on slider movement.
function slider_kon_Callback(hObject, ~, handles)
% hObject    handle to slider_kon (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'Value') returns position of slider
%        get(hObject,'Min') and get(hObject,'Max') to determine range of slider
   set(handles.edit_kon,'String',...                  %Changes text box to slider value 
   num2str(get(handles.slider_kon,'Value')));

   handles.Kon = get(handles.slider_kon,'Value');  %Converts text to number and stores as handles.Kon  
   guidata(hObject,handles);    %stores value in handles 

   
% --- Executes during object creation, after setting all properties.
function slider_kon_CreateFcn(hObject, ~, ~)
% hObject    handle to slider_kon (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: slider controls usually have a light gray background.
if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end


function edit_kequil_Callback(hObject, ~, handles)
% hObject    handle to edit_kequil (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_kequil as text
%        str2double(get(hObject,'String')) returns contents of edit_kequil as a double
val_Kequil = str2double(get(hObject,'String'));

% Determine whether val is a number between 0 and 1.
if isnumeric(val_Kequil) && length(val_Kequil)==1 && ...
   val_Kequil >= get(handles.slider_kequil,'Min') && ...
   val_Kequil <= get(handles.slider_kequil,'Max')
   set(handles.slider_kequil,'Value',val_Kequil);
   
   handles.Kequil = val_Kequil;  %Converts text to number and stores as handles.Kequil 
   guidata(hObject,handles);    %stores value in handles 
  
else
% Increment the error count, and display it.
   handles.number_errors = handles.number_errors+1;
   guidata(hObject,handles); % Store the changes.
   set(hObject,'String',...
   ['You have entered an invalid entry ',...
    num2str(handles.number_errors),' times.']);
   % Restore focus to the edit text box after error
   uicontrol(hObject)
end


% --- Executes during object creation, after setting all properties.
function edit_kequil_CreateFcn(hObject, ~, ~)
% hObject    handle to edit_kequil (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on slider movement.
function slider_kequil_Callback(hObject, ~, handles)
% hObject    handle to slider_kequil (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'Value') returns position of slider
%        get(hObject,'Min') and get(hObject,'Max') to determine range of slider
   set(handles.edit_kequil,'String',...                  % Changes text box to slider value 
   num2str(get(handles.slider_kequil,'Value')));

   handles.Kequil = get(handles.slider_kequil,'Value');  % Converts text to number and stores as handles.Kequil  
   guidata(hObject,handles);    % Stores value in handles 


% --- Executes during object creation, after setting all properties.
function slider_kequil_CreateFcn(hObject, ~, ~)
% hObject    handle to slider_kequil (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: slider controls usually have a light gray background.
if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end


function edit_tumor_void_Callback(hObject, ~, handles)
% hObject    handle to edit_tumor_void (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_tumor_void as text
%        str2double(get(hObject,'String')) returns contents of edit_tumor_void as a double
val_Void_Frac = str2double(get(hObject,'String'));

% Determine whether val is a number between 0 and 1.
if isnumeric(val_Void_Frac) && length(val_Void_Frac)==1 && ...
   val_Void_Frac >= get(handles.slider_tumor_void,'Min') && ...
   val_Void_Frac <= get(handles.slider_tumor_void,'Max')
   set(handles.slider_tumor_void,'Value',val_Void_Frac);
   
   handles.Void_frac = val_Void_Frac;  %Converts text to number and stores as handles.Void_frac 
   guidata(hObject,handles);    %stores value in handles 
else
% Increment the error count, and display it.
   handles.number_errors = handles.number_errors+1;
   guidata(hObject,handles); % Store the changes.
   set(hObject,'String',...
   ['You have entered an invalid entry ',...
    num2str(handles.number_errors),' times.']);
   % Restore focus to the edit text box after error
   uicontrol(hObject)
end


% --- Executes during object creation, after setting all properties.
function edit_tumor_void_CreateFcn(hObject, ~, ~)
% hObject    handle to edit_tumor_void (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on slider movement.
function slider_tumor_void_Callback(hObject, ~, handles)
% hObject    handle to slider_tumor_void (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'Value') returns position of slider
%        get(hObject,'Min') and get(hObject,'Max') to determine range of slider
   set(handles.edit_tumor_void,'String',...                  % Changes text box to slider value 
   num2str(get(handles.slider_tumor_void,'Value')));

   handles.Void_frac = get(handles.slider_tumor_void,'Value');  % Converts text to number and stores as handles.Void_frac  
   guidata(hObject,handles);    % Stores value in handles 

   
% --- Executes during object creation, after setting all properties.
function slider_tumor_void_CreateFcn(hObject, ~, ~)
% hObject    handle to slider_tumor_void (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: slider controls usually have a light gray background.
if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end


% --- Executes on slider movement.
function slider_SAtoV_Callback(hObject, ~, handles)
% hObject    handle to slider_SAtoV (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'Value') returns position of slider
%        get(hObject,'Min') and get(hObject,'Max') to determine range of slider
   set(handles.edit_SAtoV,'String',...                  % Changes text box to slider value 
   num2str(get(handles.slider_SAtoV,'Value')));

   handles.SAtoVratio = get(handles.slider_SAtoV,'Value');  % Converts text to number and stores as handles.SAtoVratio 
   guidata(hObject,handles);    % Stores value in handles 

   
% --- Executes during object creation, after setting all properties.
function slider_SAtoV_CreateFcn(hObject, ~, ~)
% hObject    handle to slider_SAtoV (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: slider controls usually have a light gray background.
if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end


function edit_SAtoV_Callback(hObject, ~, handles)
% hObject    handle to edit_SAtoV (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_SAtoV as text
%        str2double(get(hObject,'String')) returns contents of edit_SAtoV as a double
val_SAtoV = str2double(get(hObject,'String'));

% Determine whether val is a number between 0 and 1.
if isnumeric(val_SAtoV) && length(val_SAtoV)==1 && ...
   val_SAtoV >= get(handles.slider_SAtoV,'Min') && ...
   val_SAtoV <= get(handles.slider_SAtoV,'Max')
   set(handles.slider_SAtoV,'Value',val_SAtoV);
   
   handles.SAtoVratio = val_SAtoV;  %Converts text to number and stores as handles.SAtoVratio  
   guidata(hObject,handles);    %stores value in handles 
   
else
% Increment the error count, and display it.
   handles.number_errors = handles.number_errors+1;
   guidata(hObject,handles); % Store the changes.
   set(hObject,'String',...
   ['You have entered an invalid entry ',...
    num2str(handles.number_errors),' times.']);
   % Restore focus to the edit text box after error
   uicontrol(hObject)
end


% --- Executes during object creation, after setting all properties.
function edit_SAtoV_CreateFcn(hObject, ~, ~)
% hObject    handle to edit_SAtoV (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function edit_plasma_volume_Callback(hObject, ~, handles)
% hObject    handle to edit_plasma_volume (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_plasma_volume as text
%        str2double(get(hObject,'String')) returns contents of edit_plasma_volume as a double
val_plasma_volume = str2double(get(hObject,'String'));

% Determine whether val is a number between 0 and 1.
if isnumeric(val_plasma_volume) && length(val_plasma_volume)==1 && ...
   val_plasma_volume >= get(handles.slider_plasma_volume,'Min') && ...
   val_plasma_volume <= get(handles.slider_plasma_volume,'Max')
   set(handles.slider_plasma_volume,'Value',val_plasma_volume);
   
   handles.plasma_volume = val_plasma_volume;  %Converts text to number and stores as handles.plasma_volume  
   guidata(hObject,handles);    %stores value in handles 
   
else
% Increment the error count, and display it.
   handles.number_errors = handles.number_errors+1;
   guidata(hObject,handles); % Store the changes.
   set(hObject,'String',...
   ['You have entered an invalid entry ',...
    num2str(handles.number_errors),' times.']);
   % Restore focus to the edit text box after error
   uicontrol(hObject)
end


% --- Executes during object creation, after setting all properties.
function edit_plasma_volume_CreateFcn(hObject, ~, ~)
% hObject    handle to edit_plasma_volume (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on slider movement.
function slider_plasma_volume_Callback(hObject, ~, handles)
% hObject    handle to slider_plasma_volume (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'Value') returns position of slider
%        get(hObject,'Min') and get(hObject,'Max') to determine range of slider
   set(handles.edit_plasma_volume,'String',...                  % Changes text box to slider value 
   num2str(get(handles.slider_plasma_volume,'Value')));

   handles.plasma_volume = get(handles.slider_plasma_volume,'Value');  % Converts text to number and stores as handles.plasma_volume 
   guidata(hObject,handles);    % Stores value in handles 

   
% --- Executes during object creation, after setting all properties.
function slider_plasma_volume_CreateFcn(hObject, ~, ~)
% hObject    handle to slider_plasma_volume (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: slider controls usually have a light gray background.
if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end


function edit_cap_radius_Callback(hObject, ~, handles)
% hObject    handle to edit_cap_radius (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_cap_radius as text
%        str2double(get(hObject,'String')) returns contents of edit_cap_radius as a double
val_cap_radius = str2double(get(hObject,'String'));

% Determine whether val is a number between 0 and 1.
if isnumeric(val_cap_radius) && length(val_cap_radius)==1 && ...
   val_cap_radius >= get(handles.slider_cap_radius,'Min') && ...
   val_cap_radius <= get(handles.slider_cap_radius,'Max')
   set(handles.slider_cap_radius,'Value',val_cap_radius);
   
   handles.cap_radius = val_cap_radius;  %Converts text to number and stores as handles.cap_radius 
   guidata(hObject,handles);    %stores value in handles 
   
else
% Increment the error count, and display it.
   handles.number_errors = handles.number_errors+1;
   guidata(hObject,handles); % Store the changes.
   set(hObject,'String',...
   ['You have entered an invalid entry ',...
    num2str(handles.number_errors),' times.']);
   % Restore focus to the edit text box after error
   uicontrol(hObject)
end


% --- Executes during object creation, after setting all properties.
function edit_cap_radius_CreateFcn(hObject, ~, ~)
% hObject    handle to edit_cap_radius (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on slider movement.
function slider_cap_radius_Callback(hObject, ~, handles)
% hObject    handle to slider_cap_radius (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'Value') returns position of slider
%        get(hObject,'Min') and get(hObject,'Max') to determine range of slider
   set(handles.edit_cap_radius,'String',...                  % Changes text box to slider value 
   num2str(get(handles.slider_cap_radius,'Value')));

   handles.cap_radius = get(handles.slider_cap_radius,'Value');  % Converts text to number and stores as handles.cap_radius 
   guidata(hObject,handles);    % Stores value in handles 

   
% --- Executes during object creation, after setting all properties.
function slider_cap_radius_CreateFcn(hObject, ~, ~)
% hObject    handle to slider_cap_radius (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: slider controls usually have a light gray background.
if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end


function edit_vessel_length_Callback(hObject, ~, handles)
% hObject    handle to edit_vessel_length (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_vessel_length as text
%        str2double(get(hObject,'String')) returns contents of edit_vessel_length as a double
val_vessel_length = str2double(get(hObject,'String'));

% Determine whether val is a number between 0 and 1.
if isnumeric(val_vessel_length) && length(val_vessel_length)==1 && ...
   val_vessel_length >= get(handles.slider_vessel_length,'Min') && ...
   val_vessel_length <= get(handles.slider_vessel_length,'Max')
   set(handles.slider_vessel_length,'Value',val_vessel_length);
   
   handles.vessel_length = val_vessel_length;  %Converts text to number and stores as handles.vessel_length 
   guidata(hObject,handles);    %stores value in handles 
   
else
% Increment the error count, and display it.
   handles.number_errors = handles.number_errors+1;
   guidata(hObject,handles); % Store the changes.
   set(hObject,'String',...
   ['You have entered an invalid entry ',...
    num2str(handles.number_errors),' times.']);
   % Restore focus to the edit text box after error
   uicontrol(hObject)
end


% --- Executes during object creation, after setting all properties.
function edit_vessel_length_CreateFcn(hObject, ~, ~)
% hObject    handle to edit_vessel_length (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on slider movement.
function slider_vessel_length_Callback(hObject, ~, handles)
% hObject    handle to slider_vessel_length (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'Value') returns position of slider
%        get(hObject,'Min') and get(hObject,'Max') to determine range of slider
   set(handles.edit_vessel_length,'String',...                  % Changes text box to slider value 
   num2str(get(handles.slider_vessel_length,'Value')));

   handles.vessel_length = get(handles.slider_vessel_length,'Value');  % Converts text to number and stores as handles.vessel_length  
   guidata(hObject,handles);    % Stores value in handles 


% --- Executes during object creation, after setting all properties.
function slider_vessel_length_CreateFcn(hObject, ~, ~)
% hObject    handle to slider_vessel_length (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: slider controls usually have a light gray background.
if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end


function edit_axial_points_Callback(hObject, ~, handles)
% hObject    handle to edit_axial_points (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_axial_points as text
%        str2double(get(hObject,'String')) returns contents of edit_axial_points as a double
val_axial_points = str2double(get(hObject,'String'));

% Determine whether val is a number between 0 and 1.
if isnumeric(val_axial_points) && length(val_axial_points)==1 && ...
   val_axial_points >= get(handles.slider_axial_points,'Min') && ...
   val_axial_points <= get(handles.slider_axial_points,'Max')
   set(handles.slider_axial_points,'Value',val_axial_points);
   
   handles.axial_points = val_axial_points;  %Converts text to number and stores as handles.axial_points  
   guidata(hObject,handles);    %stores value in handles 
   
else
% Increment the error count, and display it.
   handles.number_errors = handles.number_errors+1;
   guidata(hObject,handles); % Store the changes.
   set(hObject,'String',...
   ['You have entered an invalid entry ',...
    num2str(handles.number_errors),' times.']);
   % Restore focus to the edit text box after error
   uicontrol(hObject)
end


% --- Executes during object creation, after setting all properties.
function edit_axial_points_CreateFcn(hObject, ~, ~)
% hObject    handle to edit_axial_points (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on slider movement.
function slider_axial_points_Callback(hObject, ~, handles)
% hObject    handle to slider_axial_points (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'Value') returns position of slider
%        get(hObject,'Min') and get(hObject,'Max') to determine range of slider
   set(handles.edit_axial_points,'String',...                  % Changes text box to slider value 
   num2str(get(handles.slider_axial_points,'Value')));

   handles.axial_points = get(handles.slider_axial_points,'Value');  % Converts text to number and stores as handles.axial_points  
   guidata(hObject,handles);    % Stores value in handles 


% --- Executes during object creation, after setting all properties.
function slider_axial_points_CreateFcn(hObject, ~, ~)
% hObject    handle to slider_axial_points (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: slider controls usually have a light gray background.
if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end



function edit_radial_points_Callback(hObject, ~, handles)
% hObject    handle to edit_radial_points (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_radial_points as text
%        str2double(get(hObject,'String')) returns contents of edit_radial_points as a double
val_radial_points = str2double(get(hObject,'String'));

% Determine whether val is a number between 0 and 1.
if isnumeric(val_radial_points) && length(val_radial_points)==1 && ...
   val_radial_points >= get(handles.slider_radial_points,'Min') && ...
   val_radial_points <= get(handles.slider_radial_points,'Max')
   set(handles.slider_radial_points,'Value',val_radial_points);
   
   handles.radial_points = val_radial_points;  %Converts text to number and stores as handles.radial_points  
   guidata(hObject,handles);    %stores value in handles 
   
else
% Increment the error count, and display it.
   handles.number_errors = handles.number_errors+1;
   guidata(hObject,handles); % Store the changes.
   set(hObject,'String',...
   ['You have entered an invalid entry ',...
    num2str(handles.number_errors),' times.']);
   % Restore focus to the edit text box after error
   uicontrol(hObject)
end

% --- Executes during object creation, after setting all properties.
function edit_radial_points_CreateFcn(hObject, ~, ~)
% hObject    handle to edit_radial_points (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on slider movement.
function slider_radial_points_Callback(hObject, ~, handles)
% hObject    handle to slider_radial_points (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'Value') returns position of slider
%        get(hObject,'Min') and get(hObject,'Max') to determine range of slider
   set(handles.edit_radial_points,'String',...                  % Changes text box to slider value 
   num2str(get(handles.slider_radial_points,'Value')));

   handles.radial_points = get(handles.slider_radial_points,'Value');  % Converts text to number and stores as handles.radial_points  
   guidata(hObject,handles);    % Stores value in handles 


% --- Executes during object creation, after setting all properties.
function slider_radial_points_CreateFcn(hObject, ~, ~)
% hObject    handle to slider_radial_points (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: slider controls usually have a light gray background.
if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end


function edit_simulation_time_Callback(hObject, ~, handles)
% hObject    handle to edit_simulation_time (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_simulation_time as text
%        str2double(get(hObject,'String')) returns contents of edit_simulation_time as a double
val_time = str2double(get(hObject,'String'));

% Determine whether val is a number between 0 and 1.
if isnumeric(val_time) && length(val_time)==1 && ...
   val_time >= get(handles.slider_simulation_time,'Min') && ...
   val_time <= get(handles.slider_simulation_time,'Max')
   set(handles.slider_simulation_time,'Value',val_time);
   
   handles.time = val_time;  %Converts text to number and stores as handles.time 
   guidata(hObject,handles);    %stores value in handles 
   
else
% Increment the error count, and display it.
   handles.number_errors = handles.number_errors+1;
   guidata(hObject,handles); % Store the changes.
   set(hObject,'String',...
   ['You have entered an invalid entry ',...
    num2str(handles.number_errors),' times.']);
   % Restore focus to the edit text box after error
   uicontrol(hObject)
end


% --- Executes during object creation, after setting all properties.
function edit_simulation_time_CreateFcn(hObject, ~, ~)
% hObject    handle to edit_simulation_time (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on slider movement.
function slider_simulation_time_Callback(hObject, ~, handles)
% hObject    handle to slider_simulation_time (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'Value') returns position of slider
%        get(hObject,'Min') and get(hObject,'Max') to determine range of slider
   set(handles.edit_simulation_time,'String',...                  % Changes text box to slider value 
   num2str(get(handles.slider_simulation_time,'Value')));

   handles.time = get(handles.slider_simulation_time,'Value');  % Converts text to number and stores as handles.time 
   guidata(hObject,handles);    % Stores value in handles 


% --- Executes during object creation, after setting all properties.
function slider_simulation_time_CreateFcn(hObject, ~, ~)
% hObject    handle to slider_simulation_time (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: slider controls usually have a light gray background.
if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end


function edit_free_fraction_Callback(hObject, ~, handles)
% hObject    handle to edit_free_fraction (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_free_fraction as text
%        str2double(get(hObject,'String')) returns contents of edit_free_fraction as a double
freefrac = str2double(get(hObject,'String'));

% Determine whether val is a number between 0 and 1.
if isnumeric(freefrac) && length(freefrac)==1 && ...
   freefrac >= get(handles.slider_free_fraction,'Min') && ...
   freefrac <= get(handles.slider_free_fraction,'Max')
   set(handles.slider_free_fraction,'Value',freefrac);
   
   handles.free_fraction = freefrac;  %Converts text to number and stores as handles.free_fraction 
   guidata(hObject,handles);    %stores value in handles 
   
else
% Increment the error count, and display it.
   handles.number_errors = handles.number_errors+1;
   guidata(hObject,handles); % Store the changes.
   set(hObject,'String',...
   ['You have entered an invalid entry ',...
    num2str(handles.number_errors),' times.']);
   % Restore focus to the edit text box after error
   uicontrol(hObject)
end


% --- Executes during object creation, after setting all properties.
function edit_free_fraction_CreateFcn(hObject, ~, ~)
% hObject    handle to edit_free_fraction (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on slider movement.
function slider_freefraction_Callback(hObject, ~, handles)
% hObject    handle to slider_freefraction (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'Value') returns position of slider
%        get(hObject,'Min') and get(hObject,'Max') to determine range of slider
   set(handles.edit_free_fraction,'String',...                  % Changes text box to slider value 
   num2str(get(handles.slider_free_fraction,'Value')));

   handles.free_fraction = get(handles.slider_free_fraction,'Value');  % Converts text to number and stores as handles.free_fraction  
   guidata(hObject,handles);    % Stores value in handles 


% --- Executes during object creation, after setting all properties.
function slider_freefraction_CreateFcn(hObject, ~, ~)
% hObject    handle to slider_freefraction (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: slider controls usually have a light gray background.
if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end


function edit_hem_Callback(hObject, ~, handles)
% hObject    handle to edit_hem (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_hem as text
%        str2double(get(hObject,'String')) returns contents of edit_hem as a double
hematocrit = str2double(get(hObject,'String'));

% Determine whether val is a number between 0 and 1.
if isnumeric(hematocrit) && length(hematocrit)==1 && ...
   hematocrit >= get(handles.slider_hem,'Min') && ...
   hematocrit <= get(handles.slider_hem,'Max')
   set(handles.slider_hem,'Value',hematocrit);
   
   handles.hematocrit = hematocrit;  %Converts text to number and stores as handles.hematocrit 
   guidata(hObject,handles);    %stores value in handles 
   
else
% Increment the error count, and display it.
   handles.number_errors = handles.number_errors+1;
   guidata(hObject,handles); % Store the changes.
   set(hObject,'String',...
   ['You have entered an invalid entry ',...
    num2str(handles.number_errors),' times.']);
   % Restore focus to the edit text box after error
   uicontrol(hObject)
end


% --- Executes during object creation, after setting all properties.
function edit_hem_CreateFcn(hObject, ~, ~)
% hObject    handle to edit_hem (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on slider movement.
function slider_hem_Callback(hObject, ~, handles)
% hObject    handle to slider_hem (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'Value') returns position of slider
%        get(hObject,'Min') and get(hObject,'Max') to determine range of slider
 set(handles.edit_hem,'String',...                  % Changes text box to slider value 
   num2str(get(handles.slider_hem,'Value')));

   handles.hematocrit = get(handles.slider_hem,'Value');  % Converts text to number and stores as handles.hematocrit 
   guidata(hObject,handles);    % Stores value in handles 


% --- Executes during object creation, after setting all properties.
function slider_hem_CreateFcn(hObject, ~, ~)
% hObject    handle to slider_hem (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: slider controls usually have a light gray background.
if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end


% --- Executes on slider movement.
function slider_free_fraction_Callback(hObject, ~, handles)
% hObject    handle to slider_free_fraction (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'Value') returns position of slider
%        get(hObject,'Min') and get(hObject,'Max') to determine range of slider
   set(handles.edit_free_fraction,'String',...                  % Changes text box to slider value 
   num2str(get(handles.slider_free_fraction,'Value')));

   handles.free_fraction = get(handles.slider_free_fraction,'Value');  % Converts text to number and stores as handles.free_fraction 
   guidata(hObject,handles);    % Stores value in handles 


% --- Executes during object creation, after setting all properties.
function slider_free_fraction_CreateFcn(hObject, ~, ~)
% hObject    handle to slider_free_fraction (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: slider controls usually have a light gray background.
if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end


function edit_receptor_Callback(hObject, ~, handles)
% hObject    handle to edit_receptor (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_receptor as text
%        str2double(get(hObject,'String')) returns contents of edit_receptor as a double
val_receptor = str2double(get(hObject,'String'));

% Determine whether val is a number between 0 and 1.
if isnumeric(val_receptor) && length(val_receptor)==1 && ...
   val_receptor >= get(handles.slider_receptor,'Min') && ...
   val_receptor <= get(handles.slider_receptor,'Max')
   set(handles.slider_receptor,'Value',val_receptor);
   
   handles.receptor = val_receptor;  %Converts text to number and stores as handles.receptor 
   guidata(hObject,handles);    %stores value in handles 
   
else
% Increment the error count, and display it.
   handles.number_errors = handles.number_errors+1;
   guidata(hObject,handles); % Store the changes.
   set(hObject,'String',...
   ['You have entered an invalid entry ',...
    num2str(handles.number_errors),' times.']);
   % Restore focus to the edit text box after error
   uicontrol(hObject)
end


% --- Executes during object creation, after setting all properties.
function edit_receptor_CreateFcn(hObject, ~, ~)
% hObject    handle to edit_receptor (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on slider movement.
function slider_receptor_Callback(hObject, ~, handles)
% hObject    handle to slider_receptor (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'Value') returns position of slider
%        get(hObject,'Min') and get(hObject,'Max') to determine range of slider
set(handles.edit_receptor,'String',...                  % Changes text box to slider value 
   num2str(get(handles.slider_receptor,'Value')));

   handles.receptor = get(handles.slider_receptor,'Value');  % Converts text to number and stores as handles.receptor 
   guidata(hObject,handles);    % Stores value in handles 

   
% --- Executes during object creation, after setting all properties.
function slider_receptor_CreateFcn(hObject, ~, ~)
% hObject    handle to slider_receptor (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: slider controls usually have a light gray background.
if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end


function edit_internalization_Callback(hObject, ~, handles)
% hObject    handle to edit_internalization (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_internalization as text
%        str2double(get(hObject,'String')) returns contents of edit_internalization as a double
val_internalization = str2double(get(hObject,'String'));

% Determine whether val is a number between 0 and 1.
if isnumeric(val_internalization) && length(val_internalization)==1 && ...
   val_internalization >= get(handles.slider_internalization,'Min') && ...
   val_internalization <= get(handles.slider_internalization,'Max')
   set(handles.slider_internalization,'Value',val_internalization);
   
   handles.internalization = val_internalization;  %Converts text to number and stores as handles.internalization 
   guidata(hObject,handles);    %stores value in handles 
   
else
% Increment the error count, and display it.
   handles.number_errors = handles.number_errors+1;
   guidata(hObject,handles); % Store the changes.
   set(hObject,'String',...
   ['You have entered an invalid entry ',...
    num2str(handles.number_errors),' times.']);
   % Restore focus to the edit text box after error
   uicontrol(hObject)
end


% --- Executes during object creation, after setting all properties.
function edit_internalization_CreateFcn(hObject, ~, ~)
% hObject    handle to edit_internalization (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on slider movement.
function slider_internalization_Callback(hObject, ~, handles)
% hObject    handle to slider_internalization (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'Value') returns position of slider
%        get(hObject,'Min') and get(hObject,'Max') to determine range of slider
set(handles.edit_internalization,'String',...                  % Changes text box to slider value 
   num2str(get(handles.slider_internalization,'Value')));

   handles.internalization = get(handles.slider_internalization,'Value');  % Converts text to number and stores as handles.internalization 
   guidata(hObject,handles);    % Stores value in handles 


% --- Executes during object creation, after setting all properties.
function slider_internalization_CreateFcn(hObject, ~, ~)
% hObject    handle to slider_internalization (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: slider controls usually have a light gray background.
if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end




%--------------------------------------------------------------------------------
%       @ 2 sets of code    
%--------------------------------------------------------------------------------

%Determines %ID/g calcs

%This program simulates the diffusion of antibodies from a capillary into
%the surrounding tissue in a tumor.  Cylindrical geometry is used to
%simulate diffusion outward from a capillary.  A mixed (Robin) boundary
%condition is used at the capillary wall, a no flux Neumann boundary
%condition is used at the edge of the Krogh cylinder.  This is in effect
%similar to a method of mirrors where an equal diffusion from surrounding
%capillaries prevents further diffusion from the original. The method of
%lines is used to simulate the free antibody, free antigen, and bound
%antibody-antigen complex concentrations due to binding, release,
%diffusion, catabolism, synthesis, and degradation.  Effective diffusion
%constants are used to treat the pseudo-homogenous tissue.
%The total time and number of points can be adjusted to achieve total
%saturation and accurate modeling in the most efficient amount of
%computation time.
%Greg Thurber, MIT, 2005


function [iflag] = cylindrical_model_IDpergram(handles)

%clear all;
%close all;

tic;

iflag = 0; %#ok<NASGU>

calc_dimensionless(handles); %automatically update dimensionless numbers

%__________________________________________________________________________
%Between the above and next lines are the input parameters for the model


%Input parameters in structure
Param.num_pts = round(handles.radial_points);   %number of mesh points for simulation
Param.Ab_diffusion = handles.Diff_coeff.*1e-12;   %m^2/s antibody diffusion constant

%k_off is calculated using these parameters:
Param.k_on = handles.Kon;    %per M*s
Param.K_equil = handles.Kequil.*1e-9;  %M

Param.R_Krogh = ((2*handles.cap_radius*1e-6)/(handles.SAtoVratio*100))^0.5;    %radius of tumor in meters
Param.Agen_initial = (handles.receptor.*5e11)/(6.02e23);  %mol/tumor volume - 3e-7 with epsilon=0.3 give 1 micromolar effective
Param.Abody_initial = handles.Dose.*1e-9; %M (plasma conc)  converted to tumor conc in pk function
Param.epsilon = handles.Void_frac;  %tumor void fraction

Param.R_capillary = handles.cap_radius.*1e-6;   %Radius of capillary in meters
Param.P = handles.Perm.*1e-6; %m/s based on Yuan/Dreher definition
Param.free_fraction = handles.free_fraction;

Param.ke = log(2)./(3600.*handles.internalization);    %3.5e-5 is approximately a 5 hour half-life, 1.3 is a 15 hr half life
Param.ke2 = Param.ke;  %different rate if bound?
Param.Rs = Param.ke.*Param.Agen_initial;   %if steady state, Rs should equal ke*Agen_initial

Param.density = 1000;  %tissue density in gram/L
Param.V_plasma = handles.plasma_volume.*1e-3;  %plasma volume in L (~2 mL for mouse)

t_half_blood_alpha = handles.alpha_half_life; %set in HOURS, converted to k_pharmacokinetic below
t_half_blood_beta = handles.beta_half_life; 
fraction_alpha = handles.fraction_alpha;

Param.infusion_t = 3600*0;  %infusion time in SECONDS

%if performing integration for specified time period
if(handles.count == 1)
    time_interval = handles.beta_half_life*5;    
else 
    time_interval = handles.time; 
end

%output begin, half, and full simulation time for numerical simulation
set(handles.edit_beginsimtime, 'String', '  ');
set(handles.edit_halfsimtime, 'String', '  ');
set(handles.edit_fullsimtime, 'String', '  ');


%common parameters are changed above this line
%__________________________________________________________________________

% plot image of krogh cylinder model for 1D simulation
axes(handles.axes3);
imshow('1D_Krogh.jpg');

%calculate off rate
Param.k_off = Param.k_on*Param.K_equil;  %per s

%converting time interval to seconds
tfinal = 3600*time_interval;   %seconds
t_vector = linspace(0,tfinal);

%convert half life in minutes to k in s^-1
Param.pharma_k_alpha = log(2)/(t_half_blood_alpha*3600); 
Param.pharma_k_beta = log(2)/(t_half_blood_beta*3600); 
Param.fraction_alpha = fraction_alpha;

%set up rows for initial conditions
initial_antigen = Param.Agen_initial*ones(1,Param.num_pts);
initial_antibody = zeros(1,Param.num_pts);
initial_bound = zeros(1,Param.num_pts);


initial = [initial_antibody initial_antigen initial_bound];

opt = odeset('AbsTol',1e-10);    %decrease tolerance

%Invoke ODE solver
[t,Y] = ode23s(@differential_equations, t_vector, initial, opt, Param);


%Calculating the %ID/g
%taking the average concentration in tumor divided by the initial
%concentration in blood and blood volume

sum_bound = 0;
sum_free = 0;

    
%calculates the total amount of antibody in the cylinder on an area basis
for sum_counter = 1:Param.num_pts
    
    dr = (Param.R_Krogh - Param.R_capillary)./Param.num_pts;
    r_current = Param.R_capillary + dr*(sum_counter);
    conc_current = Y(length(t),sum_counter+2*Param.num_pts);
    free_current = Y(length(t),sum_counter);
    
    sum_bound = sum_bound + 2*r_current*dr*conc_current;
    sum_free = sum_free + 2*r_current*dr*free_current;
    %no pi since divided pi out of numerator and denominator (see below)
    
end;

%normalize to average concentration
avg_Ab = (sum_bound + sum_free)./(Param.R_Krogh.^2 - Param.R_capillary^2);

%calculate %ID/g for numerical simulation
IDperG = round(100.*100.*avg_Ab./(Param.density.*Param.V_plasma.*Param.Abody_initial))./100;
set(handles.edit_IDperg, 'String', num2str(IDperG));

t_hours = t./3600;

plot(handles.axes6, 0,0);
plot(handles.axes5, 0,0);
plot(handles.axes8, 0,0);
plot(handles.axes9, 0,0);
plot(handles.axes2, 0,0);
%plot(handles.axes3, 0,0);
plot(handles.axes12, 0,0);
plot(handles.axes4, 0,0);
plot(handles.axes7, 0,0);
plot(handles.axes11, 0,0);


%Plot output

%make x axis values

%Add the capillary radius to the dimensions so will have capillary in
%between
x_minus = [linspace(-Param.R_Krogh, -Param.R_capillary, Param.num_pts), -.99*Param.R_capillary, -0.000001];
x_plus = [0, .99*Param.R_capillary, linspace(Param.R_capillary, Param.R_Krogh,Param.num_pts)];
x_axis = [x_minus, x_plus]';


plasma_conc = zeros(1,length(t));

for counter = 1:length(t)
    plasma_conc(counter) = calc_conc(Param.Abody_initial,t(counter),Param);
end;

%The above concentrations will be in overall concentrations, not interstitial
%concentrations

plot(handles.axes1, t_hours, (plasma_conc/Param.epsilon)*10^9);
xlabel(handles.axes1, 'Time (hours)'); %0 at center

if (handles.toggle == 1)
    figure;
    plot(t_hours, (plasma_conc/Param.epsilon)*10^9);
    xlabel('Time (hours)');
    ylabel('Concentration of Plasma (nM)');
end

%Create gui plot in proper axes
set(handles.axes1,'XMinorTick','on');
set(handles.axes1,'YMinorTick','on');
set(handles.axes1,'ZMinorTick','on');
grid on;

%Bound receptors
Z = [zeros(1,length(plasma_conc))', zeros(1,length(plasma_conc))', Y(:,(1+2*Param.num_pts):3*Param.num_pts)];

Zb = zeros(size(Z));
Zc = zeros(size(Z));
Zd = zeros(size(Z));

%Create mirror image so can visualize both "sides" of cylinder
for q = 1:Param.num_pts+2
    Zb(:,q) = Z(:,Param.num_pts + 3 - q);
end;
mirror = [Zb Z];

if (handles.toggle == 1)
figure;
meshc(x_axis*10^6, t_hours, mirror*10^9);
xlabel('Radius (0 at center) in microns');
ylabel('Time (hours)');
zlabel('Concentration of Bound Receptor (nM)');
title('Concentration of Bound Receptors vs. Time and Radius');
end

meshc(handles.axes10, x_axis*10^6, t_hours, mirror*10^9)
view(handles.axes10,[-150,20]);    %change the viewing angle 
set(handles.axes10,'XMinorTick','on')
set(handles.axes10,'YMinorTick','on');
set(handles.axes10,'ZMinorTick','on');
grid on
xlabel(handles.axes10, 'Radius (microns)'); %0 at center
ylabel(handles.axes10, 'Time (hours)'); %min

meshc(handles.axes11, x_axis*10^6, t_hours, mirror./Param.Agen_initial)
view(handles.axes11,[-150,20]);    %change the viewing angle 
set(handles.axes11,'XMinorTick','on')
set(handles.axes11,'YMinorTick','on');
set(handles.axes11,'ZMinorTick','on');
grid on
xlabel(handles.axes11, 'Radius (microns)'); %0 at center
ylabel(handles.axes11, 'Time (hours)'); %min
zlabel(handles.axes11, 'Fraction of Bound Receptor');

if (handles.toggle == 1)
figure;
meshc(x_axis*10^6, t_hours, mirror./Param.Agen_initial);
xlabel('Radius (0 at center) in microns');
ylabel('Time (hours)');
zlabel('Fraction of Bound Receptor');
title('Fraction of Bound Receptors vs. Time and Radius');
end

%Free antigen

Z1 = [zeros(1,length(plasma_conc))', zeros(1,length(plasma_conc))', Y(:,(1+Param.num_pts):2*Param.num_pts)];

%Create mirror image so can visualize both "sides" of cylinder
for q = 1:Param.num_pts+2
    Zc(:,q) = Z1(:,Param.num_pts + 3 - q);
end;
mirror2 = [Zc Z1];

if (handles.toggle == 1)
figure;
meshc(x_axis*10^6, t_hours, mirror2*10^9);
xlabel('Radius (0 at center) in microns');
ylabel('Time (hours)');
zlabel('Concentration of Free Antigen (nM)');
title('Concentration of Free Target vs. Time and Radius');
end

meshc(handles.axes7, x_axis*10^6, t_hours, mirror2*10^9);
view(handles.axes7,[-150,20]);    %change the viewing angle 
set(handles.axes7,'XMinorTick','on')
set(handles.axes7,'YMinorTick','on');
set(handles.axes7,'ZMinorTick','on');
grid on
xlabel(handles.axes7, 'Radius (microns)');
ylabel(handles.axes7, 'Time (hours)');


%Free antibody

Z2 = [plasma_conc'./1000, plasma_conc'./1000, Y(:,1:Param.num_pts)];

%Create mirror image so can visualize both "sides" of cylinder
for q = 1:Param.num_pts+2
    Zd(:,q) = Z2(:,Param.num_pts + 3 - q);
end;
mirror3 = [Zd Z2];

if (handles.toggle == 1)
figure;
meshc(x_axis*10^6, t_hours, mirror3*10^9);
xlabel('Radius (0 at center) in microns');
ylabel('Time (hours)');
zlabel('Concentration of Free Drug (nM)');
title('Concentration of Free Drug vs. Time and Radius');
end

meshc(handles.axes4, x_axis*10^6, t_hours, mirror3*10^9);
view(handles.axes4,[-150,20]);    %change the viewing angle 
set(handles.axes4,'XMinorTick','on')
set(handles.axes4,'YMinorTick','on');
set(handles.axes4,'ZMinorTick','on');
grid on
xlabel(handles.axes4, 'Radius (microns)');
ylabel(handles.axes4, 'Time (hours)');


plot(handles.axes6, 0,0);
plot(handles.axes5, 0,0);
plot(handles.axes8, 0,0);
plot(handles.axes9, 0,0);
plot(handles.axes2, 0,0);
%plot(handles.axes3, 0,0);
plot(handles.axes12, 0,0);

toc;

iflag = 1;

return;



%__________________________________________________________________________
%__________________________________________________________________________
%__________________________________________________________________________


%This function defines the derivatives that will be solved by a stiff
%solver.  The origin of these equations comes from material balances on the
%antibody, antigen, and bound complex concentrations.

function dY_dt = differential_equations(t,Y, Param)


dY_dt = zeros(3*Param.num_pts,1);
dR = (Param.R_Krogh-Param.R_capillary)/Param.num_pts;   %define step distance


%unpack parameters
D = Param.Ab_diffusion;
k_on = Param.k_on;
k_off = Param.k_off;
ke = Param.ke;
ke2 = Param.ke2;
Rs = Param.Rs;
Ab_exterior = calc_conc(Param.Abody_initial,t,Param);  %call function
epsilon = Param.epsilon;
R_capillary = Param.R_capillary;
P = Param.P;

%Define boundary conditions
for i = 1:Param.num_pts
    
    Ab = Y(i);
    Ag = Y(i+Param.num_pts);
    B = Y(i+2*Param.num_pts);
    
    %Because there is a void area for the capillary, the current radius
    %must be computed and used in the second derivative.  This value
    %calculates the correct current radius for each step.
    R_current = R_capillary + i*dR;
        
    if (i==1) %Robin BC at capillary wall.
              
        Abplus = Y(i+1);
        Abminus = (2*P*dR*Param.free_fraction*Ab_exterior + epsilon.*D*(4*Ab - Abplus))./(2*P*dR + 3*D*epsilon);
        
        %Ab_exterior is overall concentration, not plasma conc.
        %For higher plasma concentrations, the second term should be
        %subtracted from the first, so using the minus sign means the
        %derivative should be positive
        
    else
        if (i==Param.num_pts)  %Neumann no flux BC at outer edge
        
        Abplus = (4/3)*Y(i) - (1/3)*Y(i-1);
        Abminus = Y(i-1);
        
        else    %interior points

            Abplus = Y(i+1);  
            Abminus = Y(i-1);                       
            
        end
    end
    
%compute derivatives
%All concentrations are overall, not interstitial.

%Antibody
%Only change from spherical coordinates to cylindrical is the addition of a
%2 in the denominator of the second part of the 2nd derivative.  Normally, 
%a 2 in the numerator that is the shape factor for spheres is cancelled out
%by a 2 in the denominator from the central difference method.  The shape 
%factor for a cylinder is 1 (and 0 for planar).
dY_dt(i) = D.*(((Abminus - 2*Ab + Abplus)./(dR^2)) + (Abplus - Abminus)./(2*dR*R_current)) - k_on.*Ab.*Ag./epsilon + k_off.*B;

%Antigen
dY_dt(i+Param.num_pts) = Rs - k_on*Ab*Ag./epsilon + k_off*B - ke*Ag;

%Bound complex
dY_dt(i+2*Param.num_pts) = k_on*Ab*Ag./epsilon - k_off*B - ke2*B;

end

return;



%__________________________________________________________________________
%__________________________________________________________________________
%__________________________________________________________________________




%This function provides a two-compartment pharmacokinetic model for the
%external concentration of antibody.  It provides the antibody
%concentration in the tumor, NOT the interstitial concentration

function Ab_conc = calc_conc(Ab_initial,time,Param)

Co_plasma = Ab_initial;    %rename parameters
k_alpha = Param.pharma_k_alpha;
k_beta = Param.pharma_k_beta;
A = Param.fraction_alpha;
B = (1-A);
Co = Param.epsilon.*Co_plasma;  %convert plasma conc to overall tissue conc

if time < Param.infusion_t
    
    Ab_conc = Co;   %use if constant concentration

else
    adjusted_t = time - Param.infusion_t;
    
    Ab_conc = Co*(A.*exp(-k_alpha*adjusted_t)+B.*exp(-k_beta*adjusted_t)); %calculates exponential decay
    
end;

return;



%----------------------------------------------------------------------------
%  2nd set of code
%----------------------------------------------------------------------------

%This code simulates a Krogh cylinder with concentrations varying along the
%radius AND the length of the cylinder.  The blood flow in the inner
%cylinder will be assumed to be convective only (ignore radial gradients
%and axial diffusion) but can be depleted due to extravasation.  The
%extravasation will occur with a Robin boundary condition taking into
%account permeabilty and diffusion on the abluminal side.  radial and axial
%gradients in the tissue will be accounted for using 2 spatial dimensions
%and time.  The method of lines using finite differences will be used to
%simulate the tissue.  Comparisons between blood flow limited, permeability
%limited, diffusion limited, and local reaction limited drugs can be made.
%Greg Thurber, Harvard Medical School, Mass General Hospital, 2010

function [iflag] = Full_Krogh_w_Jacob_8_3_10(handles)


%close all;
%clear all;
%delete(handles.axes3);

iflag = 0; %#ok<NASGU> %initialize at 0, end with 1 if successful completion

tic;

calc_dimensionless(handles); %automatically update dimensionless numbers

%__________________________________________________________________________
%Parameters

Param.Nr = round(handles.radial_points);  %number of radial points (rounded to nearest integer)
Param.Nz = round(handles.axial_points);  %number of axial points (length)

Param.S_V = 100.*handles.SAtoVratio;   %radius of tumor in meters

Param.drug_diffusion = handles.Diff_coeff.*1e-12;   %m^2/s antibody diffusion constant

%k_off is calculated using these parameters:
Param.k_on = handles.Kon;    %per M*s
Param.K_equil = handles.Kequil.*1e-9;  %Molar

Param.Target_initial =(handles.receptor.*5e11)/(6.02e23);  %mol/tumor volume - 3e-7 with epsilon=0.3 give 1 micromolar effective
Param.Drug_initial = handles.Dose.*1e-9; %M (plasma conc!)  converted to tumor conc in pk function
Param.epsilon = handles.Void_frac;    %tumor void fraction
Param.H = handles.hematocrit; %blood hematocrit

Param.R_capillary = handles.cap_radius.*1e-6;   %Radius of capillary in meters
Param.P = handles.Perm.*1e-6; %m/s based on Yuan/Dreher definition
Param.free_fraction = handles.free_fraction;

Param.ke = log(2)./(3600.*handles.internalization);    %3.5e-5 is approximately a 5 hour half-life, 1.3 is a 15 hr half life
Param.ke2 = Param.ke;  %different rate if bound?
Param.Rs = Param.ke*Param.Target_initial;   %if steady state, Rs should equal ke*Agen_initial

Param.density = 1000;  %tissue density in gram/L
Param.V_plasma = handles.plasma_volume.*1e-3;  %plasma volume in L (~2 mL for mouse)

t_half_blood_alpha = handles.alpha_half_life; %0.036;   %set in HOURS, converted to k_pharmacokinetic below
t_half_blood_beta = handles.beta_half_life; %0.42;
fraction_alpha = handles.fraction_alpha; %0.8;

Param.infusion_t = 0;   %if infusing drug
Param.vel = 25e-6;
Param.vessel_length = handles.vessel_length.*1e-6;   %meters, vessel length from Baxter and Jain

%if performing integration for specified time period
if(handles.count ==1)
    %time_interval = 24*3; %set total time in HOURS for simulation
    time_interval = handles.beta_half_life*5;    
else 
    time_interval = handles.time; 
end

%output begin, half, and full simulation time for numerical simulation
beginsimtime = 0;
set(handles.edit_beginsimtime, 'String', num2str(beginsimtime));

halfsimtime = (time_interval)./2;
set(handles.edit_halfsimtime, 'String', num2str(halfsimtime));

fullsimtime = time_interval;
set(handles.edit_fullsimtime, 'String', num2str(fullsimtime));


%common parameters are changed above this line
%__________________________________________________________________________

%calculate R_Krogh
Param.R_Krogh = (2.*Param.R_capillary./Param.S_V).^(0.5);

Param.Q = Param.vel.*((Param.R_capillary)^2)/(((Param.R_Krogh)^2)*Param.vessel_length);  %blood flow in mL/g/s

%calculate off rate
Param.k_off = Param.k_on*Param.K_equil;  %per s

%Calculate vessel velocity assuming plug flow, 1 g/mL tissue density
Param.velocity = Param.Q.*(Param.R_Krogh^2).*Param.vessel_length./(Param.R_capillary^2); %m/s

%um_s_velocity = Param.velocity.*1e6; %microns/s


%converting time interval to seconds
tfinal = 3600*time_interval;   %seconds
t_vector = linspace(0,tfinal,20);

%convert half life in minutes to k in s^-1
Param.pharma_k_alpha = log(2)/(t_half_blood_alpha*3600); 
Param.pharma_k_beta = log(2)/(t_half_blood_beta*3600); 
Param.fraction_alpha = fraction_alpha;
                    
%__________________________________________________________________________
%Setting up initial parameters

initial_free_drug = zeros(Param.Nz,Param.Nr);
initial_bound = zeros(Param.Nz,Param.Nr);
initial_target = Param.Target_initial.*ones(Param.Nz,Param.Nr);
initial_blood = zeros(Param.Nz,1);

initial = [initial_free_drug initial_target initial_bound initial_blood];

t_minutes = t_vector./60;
t_hours = t_vector./3600;


%output systemic plasma concentration
plasma_conc = zeros(length(t_vector));

for plasma_count = 1:length(t_vector)
    plasma_conc(plasma_count) = calc_conc_2(Param.Drug_initial,t_vector(plasma_count),Param);
end;

%These concentrations are converted into pseudo-tissue concentrations, so
%need to divide by epsilon to get back plasma concentration

if (handles.toggle == 1)
scrsz = get(0,'ScreenSize');
figure('Position',[0 scrsz(4) scrsz(3)/4 scrsz(4)/1.5]);   %positioning plot on screen
subplot(2,1,2);
plot(t_minutes,plasma_conc*1e9./Param.epsilon);
xlabel('Time (min)');
ylabel('Plasma Concentration (nM)');
title('Systemic Plasma Concentration');
end

set(handles.axes1,'XMinorTick','on')
set(handles.axes1,'YMinorTick','on');
set(handles.axes1,'ZMinorTick','on');
grid on
plot(handles.axes1, t_minutes, plasma_conc*1e9./Param.epsilon)

xlabel(handles.axes1, 'Time (min)'); %min
%ylabel(handles.axes1, 'Plasma Conc. (nM)');
%title(handles.axes1, 'Systemic Plasma Conc.');
axis([0 t_minutes(end) 0 1e9*Param.Drug_initial]);

opt = odeset('AbsTol',1e-8,'JPattern',Krogh_cylinder_Jacobian(Param));    %decrease tolerance up to 1e-8
 

%__________________________________________________________________________
%Invoke ODE solver
[t,Y] = ode15s(@differential_equations_2, t_vector, initial, opt, Param);
%__________________________________________________________________________
%Depending on conditions, may use ode15s, ode23s, ode23t, or ode23tb

length_axis = linspace(0,Param.vessel_length,Param.Nz).*1e6;


capillary_conc = Y(:,(1+3.*Param.Nr*Param.Nz):(Param.Nz+3*Param.Nr*Param.Nz));

if (handles.toggle == 1)
subplot(2,1,1);
surfc(length_axis,t_hours, (capillary_conc./Param.epsilon)*10^9);
view([-240,20]);    %change the viewing angle 
xlabel('Length (microns)');
ylabel('Time (hours)');
title('Tumor Vessel Plasma Concentration (nM)');
end

surfc(handles.axes2, length_axis,t_hours,(capillary_conc./Param.epsilon)*10^9);
view(handles.axes2,[-240,20]);    %change the viewing angle 

set(handles.axes2,'XMinorTick','on')
set(handles.axes2,'YMinorTick','on');
set(handles.axes2,'ZMinorTick','on');
grid on
xlabel(handles.axes2, 'Length (microns)'); %microns
ylabel(handles.axes2, 'Time (hrs)'); %hrs
%zlabel(handles.axes2, 'Tumor Vessel Plasma Conc. (nM)');

%Graphing free drug concentrations
free_drug_conc_vector = Y(:,(1:Param.Nr*Param.Nz));

free_drug_matrix = zeros(Param.Nr,Param.Nz);

%stacking vector into matrix form at each time point/row

for time_count = 1:3
    
    %plot distribution at 1st time point after zero, halfway through, and
    %at end
    if time_count == 1
        time_row = 2;
    elseif time_count == 2
        time_row = round(length(t)./2);
    else
        time_row = length(t);
    end
    
    for i = 1:Param.Nr
        free_drug_matrix (i,:,time_count) = free_drug_conc_vector(time_row,(1+(i-1)*Param.Nz):i*Param.Nz);
    end
end

%Creating mirror images for easier viewing
x_minus = [linspace(-Param.R_Krogh, -Param.R_capillary, Param.Nr), -.99*Param.R_capillary, -0.000001];
x_plus = [0, .99*Param.R_capillary, linspace(Param.R_capillary, Param.R_Krogh,Param.Nr)];
x_axis = 1e6.*[x_minus, x_plus]';


%Time point 1

reflection = flipud(free_drug_matrix(:,:,1));
mirror = 1e9.*[reflection; zeros(4,Param.Nz); free_drug_matrix(:,:,1)];

if (handles.toggle == 1)
figure;
surfc(length_axis,x_axis,mirror);
view([-240,20]);    %change the viewing angle 
xlabel('Capillary Length (microns)');
ylabel('Radius (microns)');
zlabel('Free Drug Concentration (nM)');
title('Time Point 1');
end

% plot image of krogh cylinder model for 2D simulation
axes(handles.axes3);
imshow('2D_Krogh.jpg');

set(handles.axes4,'XMinorTick','on')
set(handles.axes4,'YMinorTick','on');
set(handles.axes4,'ZMinorTick','on');
grid on
surfc(handles.axes4, length_axis,x_axis,mirror);
view(handles.axes4,[-240,20]);            %change the viewing angle 
xlabel(handles.axes4,'Length (microns)'); %microns
ylabel(handles.axes4,'Radius (microns)'); %microns
%title(handles.axes4,'Free Drug Conc.');  %nM

%Time point 2
reflection = flipud(free_drug_matrix(:,:,2));
mirror = 1e9.*[reflection; zeros(4,Param.Nz); free_drug_matrix(:,:,2)];

if (handles.toggle == 1)
%subplot(3,3,2);
figure;
surfc(length_axis,x_axis,mirror);
view([-240,20]);    %change the viewing angle 
xlabel('Capillary Length (microns)');
ylabel('Radius (microns)');
zlabel('Free Drug Concentration (nM)');
title('Time Point 2');
end

set(handles.axes5,'XMinorTick','on')
set(handles.axes5,'YMinorTick','on');
set(handles.axes5,'ZMinorTick','on');
grid on


surfc(handles.axes5,length_axis,x_axis,mirror);
view(handles.axes5,[-240,20]);  %change the viewing angle  
xlabel(handles.axes5,'Length'); %microns
ylabel(handles.axes5,'Radius'); %microns

%Time point 3
reflection = flipud(free_drug_matrix(:,:,3));
mirror = 1e9.*[reflection; zeros(4,Param.Nz); free_drug_matrix(:,:,3)];

set(handles.axes6,'XMinorTick','on')
set(handles.axes6,'YMinorTick','on');
set(handles.axes6,'ZMinorTick','on');
grid on

if (handles.toggle == 1)
%subplot(3,3,3);
figure;
surfc(length_axis,x_axis,mirror);
view([-240,20]);    %change the viewing angle 
xlabel('Capillary Length (microns)');
ylabel('Radius (microns)');
zlabel('Free Drug Concentration (nM)');
title('Time Point 3');
end

surfc(handles.axes6, length_axis,x_axis,mirror);
view(handles.axes6,[-240,20]);   %change the viewing angle 
xlabel(handles.axes6, 'Length'); %microns
ylabel(handles.axes6, 'Radius'); %microns

set(handles.axes7,'XMinorTick','on')
set(handles.axes7,'YMinorTick','on');
set(handles.axes7,'ZMinorTick','on');
grid on


%Graphing unbound target concentrations
target_conc_vector = Y(:,((1+Param.Nr*Param.Nz):2*(Param.Nr*Param.Nz)));

target_matrix = zeros(Param.Nr,Param.Nz);

%stacking vector into matrix form at each time point/row

for time_count = 1:3
    
    %plot distribution at 1st time point after zero, halfway through, and
    %at end
    if time_count == 1
        time_row = 2;
    elseif time_count == 2
        time_row = round(length(t)./2);
    else
        time_row = length(t);
    end
    
    for i = 1:Param.Nr
        target_matrix (i,:,time_count) = target_conc_vector(time_row,(1+(i-1)*Param.Nz):i*Param.Nz);
    end
end


%Time point 1

reflection = flipud(target_matrix(:,:,1));
mirror = 1e9.*[reflection; zeros(4,Param.Nz); target_matrix(:,:,1)];

if (handles.toggle == 1)
figure;
surfc(length_axis,x_axis,mirror);
view([-240,20]);    %change the viewing angle 
xlabel('Capillary Length (microns)');
ylabel('Radius (microns)');
zlabel('Target Concentration (nM)');
title('Time Point 1');
end

set(handles.axes7,'XMinorTick','on')
set(handles.axes7,'YMinorTick','on');
set(handles.axes7,'ZMinorTick','on');
grid on

surfc(handles.axes7, length_axis,x_axis,mirror);
view(handles.axes7,[-240,20]);   %change the viewing angle 
xlabel(handles.axes7, 'Length'); %microns 
ylabel(handles.axes7, 'Radius'); %microns
%title(handles.axes7, 'Target Conc.');   %nM


%Time point 2
reflection = flipud(target_matrix(:,:,2));
mirror = 1e9.*[reflection; zeros(4,Param.Nz); target_matrix(:,:,2)];

if (handles.toggle == 1)
%subplot(3,3,5);
figure;
surfc(length_axis,x_axis,mirror);
view([-240,20]);    %change the viewing angle 
xlabel('Capillary Length (microns)');
ylabel('Radius (microns)');
zlabel('Target Concentration (nM)');
title('Time Point 2');
end

set(handles.axes8,'XMinorTick','on')
set(handles.axes8,'YMinorTick','on');
set(handles.axes8,'ZMinorTick','on');
grid on

surfc(handles.axes8, length_axis,x_axis,mirror);
view(handles.axes8,[-240,20]);   %change the viewing angle  
xlabel(handles.axes8, 'Length'); %microns
ylabel(handles.axes8, 'Radius'); %microns

%Time point 3
reflection = flipud(target_matrix(:,:,3));
mirror = 1e9.*[reflection; zeros(4,Param.Nz); target_matrix(:,:,3)];

if (handles.toggle == 1)
figure;
surfc(length_axis,x_axis,mirror);
view([-240,20]);    %change the viewing angle 
xlabel('Capillary Length (microns)');
ylabel('Radius (microns)');
zlabel('Target Concentration (nM)');
title('Time Point 3');
end

set(handles.axes9,'XMinorTick','on')
set(handles.axes9,'YMinorTick','on');
set(handles.axes9,'ZMinorTick','on');
grid on

surfc(handles.axes9, length_axis,x_axis,mirror);
view(handles.axes9,[-240,20]);  %change the viewing angle 
xlabel(handles.axes9,'Length'); %microns
ylabel(handles.axes9,'Radius'); %microns


%Graphing Bound target concentrations
bound_conc_vector = Y(:,((1+2*Param.Nr*Param.Nz):3*(Param.Nr*Param.Nz)));

bound_matrix = zeros(Param.Nr,Param.Nz);

%stacking vector into matrix form at each time point/row

for time_count = 1:3
    
    %plot distribution at 1st time point after zero, halfway through, and
    %at end
    if time_count == 1
        time_row = 2;
    elseif time_count == 2
        time_row = round(length(t)./2);
    else
        time_row = length(t);
    end
    
    for i = 1:Param.Nr
        bound_matrix (i,:,time_count) = bound_conc_vector(time_row,(1+(i-1)*Param.Nz):i*Param.Nz);
    end
end


%Time point 1

reflection = flipud(bound_matrix(:,:,1));
mirror = 1e9.*[reflection; zeros(4,Param.Nz); bound_matrix(:,:,1)];

if (handles.toggle == 1)
figure;
surfc(length_axis,x_axis,mirror);
view([-240,20]);    %change the viewing angle 
xlabel('Capillary Length (microns)');
ylabel('Radius (microns)');
zlabel('Bound Drug Concentration (nM)');
title('Time Point 1');
end

set(handles.axes10,'XMinorTick','on')
set(handles.axes10,'YMinorTick','on');
set(handles.axes10,'ZMinorTick','on');
grid on

surfc(handles.axes10, length_axis,x_axis,mirror);
view(handles.axes10,[-240,20]);   %change the viewing angle 
xlabel(handles.axes10,'Length');  %microns
ylabel(handles.axes10,'Radius');  %microns
%title(handles.axes10,'Bound Drug Conc.');   %(nM)


%Time point 2
reflection = flipud(bound_matrix(:,:,2));
mirror = 1e9.*[reflection; zeros(4,Param.Nz); bound_matrix(:,:,2)];

if (handles.toggle == 1)
figure;
surfc(length_axis,x_axis,mirror);
view([-240,20]);    %change the viewing angle 
xlabel('Capillary Length (microns)');
ylabel('Radius (microns)');
zlabel('Bound Drug Concentration (nM)');
title('Time Point 2');
end 

set(handles.axes11,'XMinorTick','on')
set(handles.axes11,'YMinorTick','on');
set(handles.axes11,'ZMinorTick','on');
grid on

surfc(handles.axes11,length_axis,x_axis,mirror);
view(handles.axes11,[-240,20]);    %change the viewing angle 
xlabel(handles.axes11,'Length');
ylabel(handles.axes11,'Radius');

%Time point 3
reflection = flipud(bound_matrix(:,:,3));
mirror = 1e9.*[reflection; zeros(4,Param.Nz); bound_matrix(:,:,3)];

if (handles.toggle == 1)
figure;
surfc(length_axis,x_axis,mirror);
view([-240,20]);    %change the viewing angle 
xlabel('Capillary Length (microns)');
ylabel('Radius (microns)');
zlabel('Bound Drug Concentration (nM)');
title('Time Point 3');
end

set(handles.axes12,'XMinorTick','on')
set(handles.axes12,'YMinorTick','on');
set(handles.axes12,'ZMinorTick','on');
grid on

surfc(handles.axes12, length_axis,x_axis,mirror);
view(handles.axes12,[-240,20]);    %change the viewing angle  
xlabel(handles.axes12, 'Length');  %microns
ylabel(handles.axes12,'Radius');   %microns

avg_radial_Ab = zeros(Param.Nz,1);

%calculates the total amount of probe in the cylinder
for axial_counter = 1:Param.Nz

    sum_bound = 0;
    sum_free = 0;
    
    for sum_counter = 1:Param.Nr

        dr = (Param.R_Krogh - Param.R_capillary)./Param.Nr;
        r_current = Param.R_capillary + dr*(sum_counter);
        conc_current = Y(length(t),(axial_counter + (sum_counter-1).*Param.Nz + 2.*Param.Nz.*Param.Nr));
        free_current = Y(length(t),(axial_counter + (sum_counter-1).*Param.Nz));

        sum_bound = sum_bound + 2*r_current*dr*conc_current;
        sum_free = sum_free + 2*r_current*dr*free_current;
        %no pi since divided pi out of numerator and denominator (see below)

%n = z + (r-1).*Param.Nz + (v-1).*Param.Nz.*Param.Nr;

%v = 1 for free drug
%v = 2 for free receptor
%v = 3 for bound drug
%v = 4 for blood (no radius)
        
    end;
    
    %normalize to average concentration
    avg_radial_Ab(axial_counter) = (sum_bound + sum_free)./(Param.R_Krogh.^2 - Param.R_capillary^2);
    
end;

avg_Ab = mean(avg_radial_Ab);
%avg_radial_Ab

%calculate %ID/g for numerical simulation
IDperG = round(100.*100.*avg_Ab./(Param.density.*Param.V_plasma.*Param.Drug_initial))./100;
set(handles.edit_IDperg, 'String', num2str(IDperG));

toc;

iflag = 1;

%clear all;
return;

%__________________________________________________________________________
%__________________________________________________________________________
%This function defines the differential equations

function dY_dt = differential_equations_2(t,Y, Param)


dY_dt = zeros(3*Param.Nr*Param.Nz + Param.Nz,1);
dR = (Param.R_Krogh-Param.R_capillary)/Param.Nr;   %define step distance
dZ = (Param.vessel_length)/Param.Nz;

%unpack parameters
D = Param.drug_diffusion;
k_on = Param.k_on;
k_off = Param.k_off;
ke = Param.ke;
ke2 = Param.ke2;
Rs = Param.Rs;
H = Param.H;
Drug_systemic = calc_conc_2(Param.Drug_initial,t,Param);  %call function
%Systemic conc is in overall tissue concentration units

epsilon = Param.epsilon;
R_capillary = Param.R_capillary;
P = Param.P;

%Cycle through derivatives
for radial_count = 1:Param.Nr
    
    for axial_count = 1:Param.Nz
        
        %v = 1 for free drug
        %v = 2 for free receptor
        %v = 3 for bound drug
        %v = 4 for blood (no radius)
        
        %Define drug concentrations
        Free_drug = Y(get_label(radial_count,axial_count,1,Param));
        Target = Y(get_label(radial_count,axial_count,2,Param));
        Bound = Y(get_label(radial_count,axial_count,3,Param));
        Plasma = Y(get_label(1,axial_count,4,Param));
        
        %Because there is a void area for the capillary, the current radius
        %must be computed and used in the second derivative.  This value
        %calculates the correct current radius for each step.
        R_current = R_capillary + radial_count*dR;
        
        %setting up radial boundary conditions
        if radial_count == 1    %Robin BC at capillary wall
            
            Free_drug_plus_r = Y(get_label(radial_count + 1,axial_count,1,Param));
            Free_drug_minus_r = (2*P*dR*Param.free_fraction*Plasma + epsilon*D*(4*Free_drug - Free_drug_plus_r))./(2*P*dR + 3*D*epsilon);
            
        elseif radial_count == Param.Nr    %Neumann BC at edge of cylinder
            
            Free_drug_plus_r = (4/3)*Free_drug - (1/3)*Y(get_label(radial_count - 1,axial_count,1,Param));
            Free_drug_minus_r = Y(get_label(radial_count - 1,axial_count,1,Param));
            
            
        else   %interior points
            
            Free_drug_plus_r = Y(get_label(radial_count + 1,axial_count,1,Param));
            Free_drug_minus_r = Y(get_label(radial_count - 1,axial_count,1,Param));
            
        end
               
        %setting up axial boundary conditions
        if axial_count == 1    %Neumann BC at cylinder beginning
            
            Free_drug_plus_z = Y(get_label(radial_count,axial_count + 1,1,Param));
            Free_drug_minus_z = (4/3)*Free_drug - (1/3)*Y(get_label(radial_count,axial_count + 1,1,Param));
            
        elseif axial_count == Param.Nz    %Neumann BC at end of cylinder
            
            Free_drug_plus_z = (4/3)*Free_drug - (1/3)*Y(get_label(radial_count,axial_count - 1,1,Param));
            Free_drug_minus_z = Y(get_label(radial_count,axial_count - 1,1,Param));
            
            
        else   %interior points
            
            Free_drug_plus_z = Y(get_label(radial_count,axial_count + 1,1,Param));
            Free_drug_minus_z = Y(get_label(radial_count,axial_count - 1,1,Param));
            
        end
        
        
        
        %Calculate Derivatives
        %All concentrations are in overall conc, not effective conc

        
        %Free drug
        dY_dt(axial_count + Param.Nz.*(radial_count-1)) = D.*...
            (((Free_drug_minus_z - 2*Free_drug + Free_drug_plus_z)./(dZ^2)) + ...  z-gradient
            (((Free_drug_minus_r - 2*Free_drug + Free_drug_plus_r)./(dR^2)) + ...
            (Free_drug_plus_r - Free_drug_minus_r)./(2*dR*R_current)))...   r gradient
            - k_on.*Free_drug.*Target./epsilon + k_off.*Bound;          %reaction
        %Free target
        dY_dt(axial_count + Param.Nz.*(radial_count-1) + Param.Nr*Param.Nz) = ...
            Rs - k_on.*Free_drug.*Target./epsilon + k_off*Bound - ke*Target;
        %Bound drug
        dY_dt(axial_count + Param.Nz.*(radial_count-1) + 2*Param.Nr*Param.Nz) = ...
            k_on*Free_drug*Target./epsilon - k_off*Bound - ke2*Bound;

        %__________________________________________________________________
        %Blood concentration
        
        if radial_count == 1    %only need to calculate the plasma concentration profile once
                                %use this if statement to calculate it first time through
           
                                
            if axial_count == 1     %initial condition for entrance of tumor
                
                Plasma_plus = Y(get_label(1,axial_count + 1,4,Param));
                Plasma_minus = Drug_systemic;
                
            
            elseif axial_count == Param.Nz     %No flux at capillary exit (Danckwerts BC)
              
                
                Plasma_plus = (4/3).*Y(get_label(1,axial_count,4,Param)) - ...
                    (1/3).*Y(get_label(1,axial_count - 1,4,Param));
                Plasma_minus = Y(get_label(1,axial_count - 1,4,Param));
                
           %check all BCs

            else     %interior points
                
                Plasma_plus = Y(get_label(1,axial_count + 1,4,Param));
                Plasma_minus = Y(get_label(1,axial_count - 1,4,Param));
                
            end
            
            %Derivative - note that the plasma concentration is divided by
            %epsilon since this is in an overall concentration, and the
            %difference should be in effective concentrations
            dY_dt(axial_count + 3*Param.Nr*Param.Nz) = -Param.velocity.*...
                ((Plasma_plus - Plasma_minus)./(2.*dZ)) - (2.*P./((1-H)*R_capillary))*(Param.free_fraction*Plasma - Free_drug);
            %Free_drug./epsilon
            
        end
        
               
    end %end count over axial points
end  %end count over radial points

return;


%__________________________________________________________________________
%Outputs the matrix value n given the radius and axial point.  
function n = get_label(r,z,v,Param)

n = z + (r-1).*Param.Nz + (v-1).*Param.Nz.*Param.Nr;

%v = 1 for free drug
%v = 2 for free receptor
%v = 3 for bound drug
%v = 4 for blood (no radius)

return;

%__________________________________________________________________________
%Outputs systemic antibody concentration

function Drug_conc = calc_conc_2(Drug_initial,time,Param)

Co_plasma = Drug_initial;    %rename parameters
k_alpha = Param.pharma_k_alpha;
k_beta = Param.pharma_k_beta;
A = Param.fraction_alpha;
B = (1-A);
Co = Param.epsilon.*Co_plasma;  %convert plasma conc to tumor conc

if time < Param.infusion_t
    
    Drug_conc = Co;   %use if constant concentration

else
    adjusted_t = time - Param.infusion_t;
    
    Drug_conc = Co*(A.*exp(-k_alpha*adjusted_t)+B.*exp(-k_beta*adjusted_t)); 
    %calculates exponential decay
    
end;


return;

%__________________________________________________________________________
%Outputs sparse Jacobian matrix, with all zeros except for 1's where the
%Jacobian is not equal to 0 and has to be evaluated

function Jac = Krogh_cylinder_Jacobian(Param)

N = 3*Param.Nr*Param.Nz + Param.Nz;

%initialize Jacobian as all zeros
Jac = zeros(N);

%Fill in non-zero values with ones

%loop through radial points
for radial_count = 1:Param.Nr
    
    %loop through axial points
    for axial_count = 1:Param.Nz

        %The target and bound drug are immobilized, and the number of terms
        %is not dependent on the location at the edge or corner, so these
        %Jacobian elements are the same for all points
        
            %______________________________________________________________
            %For free target
            v = 2;
            n = get_label(radial_count,axial_count,v,Param);
            
            %rxn terms
            Jac(n,n-Param.Nz*Param.Nr) = 1; %free drug
            Jac(n,n) = 1;   %rxn of free target
            Jac(n,n+Param.Nz*Param.Nr) = 1;   %bound drug            
            
            
            %______________________________________________________________
            %For bound drug
            v = 3;
            n = get_label(radial_count,axial_count,v,Param);
            
            %rxn terms
            Jac(n,n-2*Param.Nz*Param.Nr) = 1; %free drug
            Jac(n,n-Param.Nz*Param.Nr) = 1;   %free target
            Jac(n,n) = 1;   %bound drug           
            

        
    if radial_count == 1    %next to capillary
        
        %__________________________________________________________________
        %Blood derivatives (only calculate once for radial_count = 1
        %These are derivates for blood terms.  Also come into play for
        %tissue terms where have exchange w/ tissue.  These terms include
        %upstream and downstream convection
        
        if axial_count == 1;    %blood BC at entrance
        
        v = 4;
        n = get_label(radial_count,axial_count,v,Param);
        
        downstream = get_label(radial_count,axial_count+1,v,Param);
        
        Jac(n,n) = 1;           %current blood conc
        Jac(n,downstream) = 1;  %downstream blood conc for convection
        
        v = 1;  %free drug
        fd = get_label(radial_count,axial_count,v,Param);
        
        Jac(n,fd) = 1;  %exchange term w/ tissue
        
        elseif axial_count == Param.Nz;  %blood BC at exit
                   
        v = 4;
        n = get_label(radial_count,axial_count,v,Param);
        
        upstream = get_label(radial_count,axial_count-1,v,Param);
        
        Jac(n,n) = 1;
        Jac(n,upstream) = 1; 
        
        v = 1;  %free drug
        fd = get_label(radial_count,axial_count,v,Param);
        
        Jac(n,fd) = 1;  %exchange term w/ tissue
            
            
        else   %blood not at entrance or exit
            
        v = 4;
        n = get_label(radial_count,axial_count,v,Param);
        
        upstream = get_label(radial_count,axial_count-1,v,Param);
        downstream = get_label(radial_count,axial_count+1,v,Param);
        
        Jac(n,n) = 1;
        Jac(n,upstream) = 1;  
        Jac(n,downstream) = 1;
        
        v = 1;  %free drug
        fd = get_label(radial_count,axial_count,v,Param);
        
        Jac(n,fd) = 1;  %exchange term w/ tissue
            
        end
        
        
        if axial_count == 1 %corner spot at entrance
            
           %add corner spot (1)
           
            %______________________________________________________________
            %For free drug
            v = 1;
            n = get_label(radial_count,axial_count,v,Param);
            
            %rxn terms
            Jac(n,n) = 1;   %rxn of free drug
            Jac(n,n+Param.Nz*Param.Nr) = 1; %free target
            Jac(n,n+2*Param.Nz*Param.Nr) = 1;   %bound target
            
            %diffusion terms
            downstream = get_label(radial_count,axial_count+1,v,Param);
            outside = get_label(radial_count+1,axial_count,v,Param);
            
            Jac(n,downstream) = 1;
            Jac(n,outside) = 1;
            
            %tissue terms w/ respect to blood
            v = 4;
            fd = get_label(radial_count,axial_count,v,Param);
            
            Jac(n,fd) = 1;
            
           
           
        elseif axial_count == Param.Nz  %corner spot at end of vessel
            
            %add corner spot (2)
           
            %______________________________________________________________
            %For free drug
            v = 1;
            n = get_label(radial_count,axial_count,v,Param);
            
            %rxn terms
            Jac(n,n) = 1;   %rxn of free drug
            Jac(n,n+Param.Nz*Param.Nr) = 1; %free target
            Jac(n,n+2*Param.Nz*Param.Nr) = 1;   %bound target
            
            %diffusion terms
            upstream = get_label(radial_count,axial_count-1,v,Param);
            outside = get_label(radial_count+1,axial_count,v,Param);
            
            Jac(n,upstream) = 1;
            Jac(n,outside) = 1;
            
            %tissue terms w/ respect to blood
            v = 4;
            fd = get_label(radial_count,axial_count,v,Param);
            
            Jac(n,fd) = 1;
            
            
        else
            
            %add all spots next to capillary (including interactions w/
            %vessel (edge A)
            
            %______________________________________________________________
            %For free drug
            v = 1;
            n = get_label(radial_count,axial_count,v,Param);
            
            %rxn terms
            Jac(n,n) = 1;   %rxn of free drug
            Jac(n,n+Param.Nz*Param.Nr) = 1; %free target
            Jac(n,n+2*Param.Nz*Param.Nr) = 1;   %bound target
            
            %diffusion terms
            upstream = get_label(radial_count,axial_count-1,v,Param);
            downstream = get_label(radial_count,axial_count+1,v,Param);
            outside = get_label(radial_count+1,axial_count,v,Param);
            
            Jac(n,upstream) = 1;
            Jac(n,downstream) = 1;
            Jac(n,outside) = 1;
            
            %tissue terms w/ respect to blood
            v = 4;
            fd = get_label(radial_count,axial_count,v,Param);
            
            Jac(n,fd) = 1;
            

            
        end
    
    
    elseif radial_count == Param.Nr
        
        if axial_count == 1 %corner spot at entrance
            
           %add corner spot (3)
            
           %______________________________________________________________
            %For free drug
            v = 1;
            n = get_label(radial_count,axial_count,v,Param);
            
            %rxn terms
            Jac(n,n) = 1;   %rxn of free drug
            Jac(n,n+Param.Nz*Param.Nr) = 1; %free target
            Jac(n,n+2*Param.Nz*Param.Nr) = 1;   %bound target
            
            %diffusion terms
            downstream = get_label(radial_count,axial_count+1,v,Param);
            inside = get_label(radial_count-1,axial_count,v,Param);
            
            Jac(n,downstream) = 1;
            Jac(n,inside) = 1;
            

           
        elseif axial_count == Param.Nz  %corner spot at end of vessel
            
            %add corner spot (4)
            
            %______________________________________________________________
            %For free drug
            v = 1;
            n = get_label(radial_count,axial_count,v,Param);
            
            %rxn terms
            Jac(n,n) = 1;   %rxn of free drug
            Jac(n,n+Param.Nz*Param.Nr) = 1; %free target
            Jac(n,n+2*Param.Nz*Param.Nr) = 1;   %bound target
            
            %diffusion terms
            upstream = get_label(radial_count,axial_count-1,v,Param);
            inside = get_label(radial_count-1,axial_count,v,Param);
            
            Jac(n,upstream) = 1;
            Jac(n,inside) = 1;

            
        else
            
            %add all spots at Krogh cylinder edge (edge C)
            
            %______________________________________________________________
            %For free drug
            v = 1;
            n = get_label(radial_count,axial_count,v,Param);
            
            %rxn terms
            Jac(n,n) = 1;   %rxn of free drug
            Jac(n,n+Param.Nz*Param.Nr) = 1; %free target
            Jac(n,n+2*Param.Nz*Param.Nr) = 1;   %bound target
            
            %diffusion terms
            upstream = get_label(radial_count,axial_count-1,v,Param);
            downstream = get_label(radial_count,axial_count+1,v,Param);
            inside = get_label(radial_count-1,axial_count,v,Param);
            
            Jac(n,upstream) = 1;
            Jac(n,downstream) = 1;
            Jac(n,inside) = 1;

            
        end
        
    elseif axial_count == 1  %but not including corners since else statement
        
            %add all spots at vessel entrance (edge B)
            
            %______________________________________________________________
            %For free drug
            v = 1;
            n = get_label(radial_count,axial_count,v,Param);
            
            %rxn terms
            Jac(n,n) = 1;   %rxn of free drug
            Jac(n,n+Param.Nz*Param.Nr) = 1; %free target
            Jac(n,n+2*Param.Nz*Param.Nr) = 1;   %bound target
            
            %diffusion terms
            downstream = get_label(radial_count,axial_count+1,v,Param);
            inside = get_label(radial_count-1,axial_count,v,Param);
            outside = get_label(radial_count+1,axial_count,v,Param);
            
            Jac(n,downstream) = 1;
            Jac(n,inside) = 1;
            Jac(n,outside) = 1;

            
    elseif axial_count == Param.Nz
        
            %add all spots at vessel exit (edge D)
            
            %______________________________________________________________
            %For free drug
            v = 1;
            n = get_label(radial_count,axial_count,v,Param);
            
            %rxn terms
            Jac(n,n) = 1;   %rxn of free drug
            Jac(n,n+Param.Nz*Param.Nr) = 1; %free target
            Jac(n,n+2*Param.Nz*Param.Nr) = 1;   %bound target
            
            %diffusion terms
            upstream = get_label(radial_count,axial_count-1,v,Param);
            inside = get_label(radial_count-1,axial_count,v,Param);
            outside = get_label(radial_count+1,axial_count,v,Param);
            
            Jac(n,upstream) = 1;
            Jac(n,inside) = 1;
            Jac(n,outside) = 1;

            
    else
        
            %add all interior points, no corners, no edges
            
            %v = 1 for free drug
            %v = 2 for free receptor
            %v = 3 for bound drug
            %v = 4 for blood (no radius)
            
            %______________________________________________________________
            %For free drug
            v = 1;
            n = get_label(radial_count,axial_count,v,Param);
            
            %rxn terms
            Jac(n,n) = 1;   %rxn of free drug
            Jac(n,n+Param.Nz*Param.Nr) = 1; %free target
            Jac(n,n+2*Param.Nz*Param.Nr) = 1;   %bound target
            
            %diffusion terms
            upstream = get_label(radial_count,axial_count-1,v,Param);
            downstream = get_label(radial_count,axial_count+1,v,Param);
            inside = get_label(radial_count-1,axial_count,v,Param);
            outside = get_label(radial_count+1,axial_count,v,Param);
            
            Jac(n,upstream) = 1;
            Jac(n,downstream) = 1;
            Jac(n,inside) = 1;
            Jac(n,outside) = 1;

            
    end    %ending all if statments for corners and edges
         
    end    %ending axial point loop
end        %ending radial point loop

return


% --- Executes on button press in pushbutton_calc.
function calc_dimensionless(handles)
% hObject    handle to pushbutton_calc (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
P = handles.Perm*1e-6;                  %convert to m/s
Rcap = handles.cap_radius*1e-6;         %convert to m
D = handles.Diff_coeff*1e-12;           %convert to m^2/s
voidfrac = handles.Void_frac;          
Lkrogh = handles.vessel_length*1e-6;    %convert to m
v = 25e-6;  %convert to m/s
variableAntigenDensity = (handles.receptor.*5e11)/(6.02e23);
krxn = handles.Kon*variableAntigenDensity;             %convert to /s

H = handles.hematocrit; 
SAtoV = handles.SAtoVratio*100;         %convert to /m 
FracFree = handles.free_fraction;

Rkrogh = ((2*Rcap)/(SAtoV))^0.5;
Q = v*(Rcap^2)/((Rkrogh^2)*Lkrogh);

Biot = (2*P*Rcap)/(D*voidfrac);

Damkohler = (krxn*(Rkrogh^2))/(D*voidfrac);

VesselDepletion = (P*FracFree*SAtoV)/(Q*(1-H));

set(handles.edit_biot, 'String', num2str(Biot))
set(handles.edit_damkohler, 'String', num2str(Damkohler))
set(handles.edit_vessel_dep, 'String', num2str(VesselDepletion))

VD = VesselDepletion;
Bi = Biot;
Da = Damkohler;

if(VD < 1 && Bi < 1 && (Bi/Da) < 1)
    a = 2;
    set(handles.edit_class, 'String', num2str(a))
elseif(Bi > 1 && Da > 1 && (VD/Bi) < 1)
    a = 3;
    set(handles.edit_class, 'String', num2str(a))
elseif(Da < 1 && (Bi/Da) > 1 && (VD*Da/Bi) < 1)
    a = 4;
    set(handles.edit_class, 'String', num2str(a)) 
elseif(VD > 1 && (VD/Bi) > 1 && (VD*Da/Bi) > 1)
    a = 1;
    set(handles.edit_class, 'String', num2str(a))  
else   
    a = 0;
    set(handles.edit_class, 'String', num2str(a))
end

return


function edit_IDperg_Callback(~, ~, ~)
% hObject    handle to edit_IDperg (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_IDperg as text
%        str2double(get(hObject,'String')) returns contents of edit_IDperg as a double


% --- Executes during object creation, after setting all properties.
function edit_IDperg_CreateFcn(hObject, ~, ~)
% hObject    handle to edit_IDperg (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function edit_halfsimtime_Callback(~, ~, ~)
% hObject    handle to edit_halfsimtime (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_halfsimtime as text
%        str2double(get(hObject,'String')) returns contents of edit_halfsimtime as a double


% --- Executes during object creation, after setting all properties.
function edit_halfsimtime_CreateFcn(hObject, ~, ~)
% hObject    handle to edit_halfsimtime (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function edit_fullsimtime_Callback(~, ~, ~)
% hObject    handle to edit_fullsimtime (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_fullsimtime as text
%        str2double(get(hObject,'String')) returns contents of edit_fullsimtime as a double


% --- Executes during object creation, after setting all properties.
function edit_fullsimtime_CreateFcn(hObject, ~, ~)
% hObject    handle to edit_fullsimtime (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function edit_beginsimtime_Callback(~, ~, ~)
% hObject    handle to edit_beginsimtime (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_beginsimtime as text
%        str2double(get(hObject,'String')) returns contents of edit_beginsimtime as a double


% --- Executes during object creation, after setting all properties.
function edit_beginsimtime_CreateFcn(hObject, ~, ~)
% hObject    handle to edit_beginsimtime (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



% --- Executes on button press in checkbox2.
function checkbox2_Callback(hObject, ~, handles)
% hObject    handle to checkbox2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of checkbox2
if (get(hObject,'Value') == get(hObject,'Max'))
    handles.toggle = 1;
    guidata(hObject,handles);    % Stores value in handles 
    
else
    handles.toggle = 0;
    guidata(hObject,handles);    % Stores value in handles
    
end
    
